-*- coding: utf-8 -*-

commit e51014f9c05aa65cbf203442d37fef7c12390015
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-30 20:06:29 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-30 20:06:29 +0900

    v3.2.2p53

commit 936b705d7839f78d88a1dde5ba4ca309848dd792
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-30 19:55:41 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-30 20:05:11 +0900

    v3.2.1p53

commit 34d5d10517825a51bea6bcb13ead1484c7182b42
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-30 19:54:12 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-03-30 19:54:12 +0900

    Merge Time-0.2.2 (#7623)

commit 250ff4ff45f1257b395260fe42d914cbb0720a41
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-29 00:47:10 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-29 00:48:11 +0900

    gem related automation must run only on master

commit 00041131e25699136179a7de06794527eaaabfd6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-02-22 22:14:26 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-28 22:47:23 +0900

    Skip failing test on MSWin

commit 18d3223563cc74b07e53e79c44d45dc50a6004c7
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-28 21:01:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-28 21:04:02 +0900

    Use merge_group

commit c3c461c4ff1b998ac49ed1a3ad411d2f0a9123b8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 20:36:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-03-28 20:36:47 +0900

    Merge RubyGems-3.4.10 and Bundler-2.4.10 (#7479)

    * Merge RubyGems-3.4.7 and Bundler-2.4.7

    * Merge RubyGems-3.4.8 and Bundler-2.4.8

    * Skip failing test on MSWin

    * Merge RubyGems-3.4.9 and Bundler-2.4.9

    * Merge RubyGems-3.4.10 and Bundler-2.4.10

    ---------

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit f8c775cb413724a45bb5641de94f4f9210044116
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 20:36:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-03-28 20:36:36 +0900

    Use URI-0.12.1 for Ruby 3.2 (#7603)

    * Merge URI-0.12.1

    * Use URI-0.12.1

    * Update core_assertions for using assert_linear_performance

commit 582aadb3905eac131591f4c7884f441c036c49fb
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-28 17:02:53 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-28 17:02:53 +0900

    merge revision(s) 2f916812a9b818b432ee7c299e021ec62d4727fb,ac458f6bc3c520c9f23364c85bfb033acda907a6:

            Skip test_europe_lisbon on macOS

            until we figure out why it's failing.
            ---
             test/ruby/test_time_tz.rb | 1 +
             1 file changed, 1 insertion(+)

            Historical timezones of Lisbon in tzdata are unstable

            ---
             test/ruby/test_time_tz.rb | 3 +--
             1 file changed, 1 insertion(+), 2 deletions(-)

commit fb4ffce0dd8cae3b7d0141d3b1ea3f0ab710a45a
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-28 14:25:13 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-28 14:25:13 +0900

    merge revision(s) 680bd9027f8cb7977bbc216609db2f4e3cf199a8: [Backport #19471]

            [Bug #19471] `Regexp.compile` should handle keyword arguments

            As well as `Regexp.new`, it should pass keyword arguments to the
            `Regexp#initialize` method.
            ---
             re.c                     | 2 +-
             test/ruby/test_regexp.rb | 5 +++++
             2 files changed, 6 insertions(+), 1 deletion(-)

commit b93e2223300bc54dfa387ffb9fa3d48ecbe670f0
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-23 12:04:46 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-23 12:04:46 +0900

    merge revision(s) e7342e76dfd26237c604e42f9a59a1eaa578c94e: [Backport #19485]

            [Bug #19485] [DOC] Mention tabs in indentation of heredoc identifier

            Co-Authored-By: sawa (Tsuyoshi Sawada) <sawadatsuyoshi@gmail.com>
            ---
             doc/syntax/literals.rdoc | 6 ++++++
             1 file changed, 6 insertions(+)

commit 400ccb16eefe4e21c4e3eacab4fd0f208fc5e151
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-23 08:11:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-23 08:11:23 +0900

    merge revision(s) cb22d78354e201ca74eba68a8b4edefb593e6754: [Backport #19536]

            Fix frozen status loss when moving objects

            [Bug #19536]

            When objects are moved between size pools, their frozen status is lost
            in the shape. This will cause the frozen check to be bypassed when there
            is an inline cache. For example, the following script should raise a
            FrozenError, but doesn't on Ruby 3.2 and master.

                class A
                  def add_ivars
                    @a = @b = @c = @d = 1
                  end

                  def set_a
                    @a = 10
                  end
                end

                a = A.new
                a.add_ivars
                a.freeze

                b = A.new
                b.add_ivars
                b.set_a # Set the inline cache in set_a

                GC.verify_compaction_references(expand_heap: true, toward: :empty)

                a.set_a
            ---
             shape.c                      |  2 +-
             test/ruby/test_gc_compact.rb | 28 ++++++++++++++++++++++++++++
             2 files changed, 29 insertions(+), 1 deletion(-)

commit ad6fe84dfa6935bd6e2c3ef3ee36bed4e8627d0b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-22 10:34:12 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-22 10:34:12 +0900

    merge revision(s) dddc542e9b61b292d80a96d0d0efbbf58719e3be: [Backport #19476]

            [Bug #19476]: correct cache index computation for repetition (#7457)

            ---
             regexec.c                | 4 ++--
             test/ruby/test_regexp.rb | 5 +++++
             2 files changed, 7 insertions(+), 2 deletions(-)

commit 4b4087dce318570f9f9c05e14900325b499fb632
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-20 15:06:34 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-20 15:06:34 +0900

    merge revision(s) e22c4e8877677ff90805e4a4dcbdef80f4220136: [Backport #19467]

            [Bug #19467] correct cache points and counting failure on
             `OP_ANYCHAR_STAR_PEEK_NEXT` (#7454)

            ---
             regexec.c                | 20 ++++++++++++++++----
             test/ruby/test_regexp.rb | 10 ++++++++++
             2 files changed, 26 insertions(+), 4 deletions(-)

commit 0555303464f3595223ec8093146041f96595865d
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-18 15:02:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-18 15:02:04 +0900

    merge revision(s) 96d1acfdf6c6b42f2029f44d5b5920961d6efa92: [Backport #19161]

            [Bug #19161] Check for TLS usability

            On all platforms using GCC, even other than darwin.
            ---
             configure.ac | 13 +++++++------
             1 file changed, 7 insertions(+), 6 deletions(-)

commit f3abe5ba645839fb2a686aee18d3466b59256af0
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-17 13:40:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-17 13:40:04 +0900

    merge revision(s) 0700d0fd1c77b4fddf803dea3c10be654df600ff,62c2082f1f726cb90d8c332fbedbecf41d5d82ec: [Backport #19469]

            Fix indentation in vm_setivar_default

            ---
             vm_insnhelper.c | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

            [Bug #19469] Fix crash when resizing generic iv list

            The following script can sometimes trigger a crash:

            ```ruby
            GC.stress = true

            class Array
              def foo(bool)
                if bool
                  @a = 1
                  @b = 2
                  @c = 1
                else
                  @c = 1
                end
              end
            end

            obj = []
            obj.foo(true)

            obj2 = []
            obj2.foo(false)

            obj3 = []
            obj3.foo(true)
            ```

            This is because vm_setivar_default calls rb_ensure_generic_iv_list_size
            to resize the iv list. However, the call to gen_ivtbl_resize reallocs
            the iv list, and then inserts into the generic iv table. If the
            st_insert triggers a GC then the old iv list will be read during
            marking, causing a use-after-free bug.

            Co-Authored-By: Jemma Issroff <jemmaissroff@gmail.com>
            ---
             internal/variable.h |  2 +-
             variable.c          | 23 ++++++++++++++++++-----
             vm_insnhelper.c     |  4 ++--
             3 files changed, 21 insertions(+), 8 deletions(-)

commit b309c246ee70926d593d3857e1625202e2d0f67b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-17 10:56:18 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-17 10:56:18 +0900

    merge revision(s) d78ae78fd76e556e281a743c75bea4c0bb81ed8c: [Backport #19468]

            rb_str_modify_expand: clear the string coderange

            [Bug #19468]

            b0b9f7201acab05c2a3ad92c3043a1f01df3e17f errornously stopped
            clearing the coderange.

            Since `rb_str_modify` clears it, `rb_str_modify_expand`
            should too.
            ---
             string.c | 1 +
             1 file changed, 1 insertion(+)

commit b73a07359758a9034996752e981e09ddaffe8d87
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-15 16:36:32 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-15 16:36:32 +0900

    merge revision(s) 0eb634ae73cb327ede833b72492f912792a4a9d5: [Backport #19464]

            YJIT: Detect and reject `send(:alias_for_send, :foo)`

            Previously, YJIT failed to put the stack into the correct shape when
            `BasicObject#send` calls an alias method for the send method itself.
            This can manifest as strange `NoMethodError`s in the final non-send
            receiver, as [seen][1] with the kt-paperclip gem. I also found a case
            where it makes YJIT fail the stack size assertion while compiling
            `leave`.

            YJIT's `BasicObject#__send__` implementation already rejects sends to
            `send`, but didn't detect sends to aliases of `send`. Adjust the
            detection and reject these cases.

            Fixes [Bug #19464]

            [1]: https://github.com/Shopify/yjit/issues/306
            ---
             test/ruby/test_yjit.rb | 20 ++++++++++++++++++++
             yjit/src/codegen.rs    | 25 ++++++++++---------------
             2 files changed, 30 insertions(+), 15 deletions(-)

commit db28f7003f7d49cfa13871c38d10c1967282ca6b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-09 09:35:39 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-09 09:35:39 +0900

    merge revision(s) 3b567eb491e460e00a66fdea8054eeb083b5dafd: [Backport #19459]

            [Bug #19459] Remove unnecessary always-true checks (#7362)

            `length` is a required argument for `IO::Buffer#read` and
            `IO::Buffer#write` methods, and `argc` is already checked with
            `rb_check_arity`.  Also fix the call-seq of `IO::Buffer#read`.
            ---
             io_buffer.c | 24 +++++++-----------------
             1 file changed, 7 insertions(+), 17 deletions(-)

commit 4e4a4e42b284d9309a7e51c97058093539e7a843
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-08 14:46:30 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-08 14:46:30 +0900

    merge revision(s) d2520b7b76759118071a16e6bca22726a5de9fb4: [Backport #19439]

            Marshal.load: restore instance variables on Regexp

            [Bug #19439]

            The instance variables were restore on the Regexp source,
            not the regexp itself.

            Unfortunately we have a bit of a chicken and egg problem.

            The source holds the encoding, and the encoding need to be set on
            the source to be able to instantiate the Regexp.

            So the instance variables have to be read on the `source`.
            To correct this we transfert the instance variables after
            instantiating the Regexp.

            The only way to avoid this would be to read the instance variable
            twice and rewind.
            ---
             marshal.c                             | 20 ++++++++++++++++++--
             spec/ruby/core/marshal/shared/load.rb | 11 +++++++++++
             2 files changed, 29 insertions(+), 2 deletions(-)

commit 59eb18037ff92839be48fb6c46ff0acc179b4f4c
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-08 12:02:22 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-08 12:02:22 +0900

    merge revision(s) dd28c55a7cd6780dad637b4d6a20507fbfc6af4a: [Backport #19445]

            [Bug#19445] Fix keyword splat in enumerator

            Extracted arguments do not have keyword hash to splat.
            ---
             numeric.c                 | 2 +-
             test/ruby/test_numeric.rb | 3 +++
             2 files changed, 4 insertions(+), 1 deletion(-)

commit 4d75035e1762a23d38c5192b30bb47f40b752bee
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-07 19:48:32 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-07 19:48:32 +0900

    merge revision(s) c178926fbe879045fa711444a1fd9e906af23e3b,a4b7ec12298c78392797e5ba7704076550e4f100: [Backport #19444]

            YJIT: jit_prepare_routine_call() for String#+@ missing

            We saw SEGVs due to this when running with StackProf, which needs a
            correct PC for RUBY_INTERNAL_EVENT_NEWOBJ, the same event used for
            ObjectSpace allocation tracing.

            [Bug #19444]
            ---
             test/ruby/test_yjit.rb | 27 +++++++++++++++++++++++++++
             yjit/src/codegen.rs    |  5 ++++-
             2 files changed, 31 insertions(+), 1 deletion(-)

            YJIT: Fix false assumption that String#+@ => ::String

            Could return a subclass.

            [Bug #19444]
            ---
             test/ruby/test_yjit.rb | 17 +++++++++++++++++
             yjit/src/codegen.rs    | 10 +++++++---
             2 files changed, 24 insertions(+), 3 deletions(-)

commit f1cde05d99898f491c8e302ae74029468fdb6eb9
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-07 10:11:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-07 10:11:43 +0900

    merge revision(s) 86de48e9f69b665ba9ffb5bdc5a181a3adb1a7b8: [Backport #19419]

            Remove ibf_dumper's WB_PROTECTED status

            It doesn't have the right write barriers in place. For example, there is

                rb_mark_set(dump->global_buffer.obj_table);

            in the mark function, but there is no corresponding write barrier when
            adding to the table in the
            `ibf_dump_object() -> ibf_table_find_or_insert() -> st_insert()` code path.

            To insert write barrier correctly, we need to store the T_STRUCT VALUE
            inside `struct ibf_dump`. Instead of doing that, let's just demote it
            to WB unproected for correctness. These dumper object are ephemeral so
            there is not a huge benefit for having them WB protected.

            Users of the bootsnap gem ran into crashes due to this issue:
            https://github.com/Shopify/bootsnap/issues/436

            Fixes [Bug #19419]
            ---
             compile.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit f93c7b9f58966fd04496bfeb2538fb1ff41f788e
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-04 15:39:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-04 15:39:47 +0900

    merge revision(s) b78f871d838c168789648738e5c67b071beb8a19,ecd0cdaf820af789f355f1a18c31d6adfe8aad94: [Backport #19400]

            YJIT: Use the system page size when the code page size is too small
             (#7267)

            Previously on ARM64 Linux systems that use 64 KiB pages
            (`CONFIG_ARM64_64K_PAGES=y`), YJIT was panicking on boot due to a failed
            assertion.

            The assertion was making sure that code GC can free the last code page
            that YJIT manages without freeing unrelated memory. YJIT prefers picking
            16 KiB as the granularity at which to free code memory, but when the
            system can only free at 64 KiB granularity, that is not possible.

            The fix is to use the system page size as the code page size when the
            system page size is 64 KiB. Continue to use 16 KiB as the code page size
            on common systems that use 16/4 KiB pages.

            Add asserts to code_gc() and free_page() about code GC's assumptions.

            Fixes [Bug #19400]
            ---
             yjit/src/asm/mod.rs    | 78 ++++++++++++++++++++++++++++++++------------------
             yjit/src/codegen.rs    |  2 --
             yjit/src/virtualmem.rs | 13 +++++++++
             3 files changed, 63 insertions(+), 30 deletions(-)

            YJIT: Fix assertion for partially mapped last pages (#7337)

            Follows up [Bug #19400]
            ---
             test/ruby/test_yjit.rb | 19 +++++++++++++++++++
             yjit/src/asm/mod.rs    |  2 +-
             yjit/src/virtualmem.rs | 18 +++++++++++++-----
             3 files changed, 33 insertions(+), 6 deletions(-)

commit 53f6173cfc085a7422b4a76c85e6c35969209327
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-03-02 09:28:58 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-03-02 09:29:38 +0900

    merge revision(s) 8ce2fb9bbbaea14737c84385b1573f743a30f773,3a0f6ce1d31eefd8af01b50f3632a64d64e8f8c1: [Backport #19415]

            Only emit circular dependency warning for owned thread shields [Bug
             #19415]

            If multiple threads attemps to load the same file concurrently
            it's not a circular dependency issue.

            So we check that the existing ThreadShield is owner by the current
            fiber before warning about circular dependencies.
            ---
             internal/thread.h                                     |  1 +
             load.c                                                |  3 ++-
             spec/ruby/core/kernel/shared/require.rb               | 11 +++++++++++
             spec/ruby/fixtures/code/concurrent_require_fixture.rb |  4 ++++
             test/ruby/test_require.rb                             |  3 ---
             thread.c                                              | 11 +++++++++++
             6 files changed, 29 insertions(+), 4 deletions(-)
             create mode 100644 spec/ruby/fixtures/code/concurrent_require_fixture.rb

            Use Thread.pass until thread.stop? to wait for thread to block

            [Bug #19415]

            It should be more reliable
            ---
             spec/ruby/fixtures/code/concurrent_require_fixture.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 65ab2c1ef23bd4a02120a27c371dce12ea9024d4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-02-22 19:00:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-02-22 19:00:00 +0900

    Backport [Bug #19158] for Ruby 3.2 (#7356)

    Backport https://github.com/ruby/ruby/pull/7321

commit 31819e82c88c6f8ecfaeb162519bfa26a14b21fd
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-02-08 13:02:20 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-02-08 13:02:20 +0900

    v3.2.1

commit 88e0862267cec6764ab9888f7522a40f2996e2c7
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-02-08 01:31:22 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-02-08 01:31:22 +0900

    Remove wrong file

commit 3decf7df6f678ff6386c5c1888642d76f49dc147
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-02-07 15:15:17 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-02-07 15:15:17 +0900

    merge revision(s) 3a7367ccc319499127ead147e5a08f769e44208e: [Backport #19403]

            mkconfig: Map `includedir` only for system ruby

            Only when installing to the system path on macOS, prepend '$(SDKROOT)'
            and remap `includedir`.
            Fix https://github.com/rbenv/ruby-build/discussions/2123
            ---
             test/mkmf/test_config.rb | 4 ++--
             test/test_rbconfig.rb    | 9 ---------
             tool/mkconfig.rb         | 4 +++-
             3 files changed, 5 insertions(+), 12 deletions(-)

commit 7246cd0081ec845e1407484fca10439e7868880b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-02-07 13:46:36 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-02-07 13:46:36 +0900

    merge revision(s) fad48fefe19cc282a5b209944244a3713359b47f: [Backport #19399]

            [Bug #19399] Parsing invalid heredoc inside block parameter

            Although this is of course invalid as Ruby code, allow to just parse
            and tokenize.
            ---
             ext/ripper/lib/ripper/lexer.rb |  2 +-
             test/ripper/test_lexer.rb      | 12 ++++++++++++
             2 files changed, 13 insertions(+), 1 deletion(-)

commit 3426ebd0489654f951a8b92efaf5e72b9f43efab
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-02-06 16:41:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-02-06 16:41:23 +0900

    merge revision(s) c6f84e918943a0bf8db6fee556fc53180d257510: [Backport #19398]

            [Bug #19398] Memory leak in WeakMap

            There's a memory leak in ObjectSpace::WeakMap due to not freeing
            the `struct weakmap`. It can be seen in the following script:

            ```
            100.times do
              10000.times do
                ObjectSpace::WeakMap.new
              end

              # Output the Resident Set Size (memory usage, in KB) of the current Ruby process
              puts `ps -o rss= -p #{$$}`
            end
            ```
            ---
             gc.c                      | 1 +
             test/ruby/test_weakmap.rb | 9 +++++++++
             2 files changed, 10 insertions(+)

commit 3a88589399f7f1059be245f766809c49790ad939
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-02-06 14:00:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-02-06 14:00:47 +0900

    merge revision(s) 3b83b265f11965582d4b9b439eff8a501792ab68: [Backport #19404]

            YJIT: Crash with rb_bug() when panicking

            Helps with getting good bug reports in the wild. Intended to be
            backported to the 3.2.x series.
            ---
             yjit/bindgen/src/main.rs       |  3 +++
             yjit/src/cruby_bindings.inc.rs |  1 +
             yjit/src/yjit.rs               | 29 +++++++++++++++++++++++++++--
             3 files changed, 31 insertions(+), 2 deletions(-)

commit 535d863f34e6c36a2378683e7c2d3b7369e3d076
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-02-03 14:13:02 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-02-03 14:13:09 +0900

    merge revision(s) 188688a53e7708d25ab80e14d05e70ffcf792e13: [Backport #19385]

            [PATCH 1/4] YJIT: Move CodegenGlobals::freed_pages into an Rc

            This allows for supplying a freed_pages vec in Rust tests. We need it so we
            can test scenarios that occur after code GC.
            ---
             yjit/src/asm/mod.rs | 48 +++++++++++++++++++++++++++++++++------------
             yjit/src/codegen.rs | 16 ++++-----------
             2 files changed, 39 insertions(+), 25 deletions(-)

            Subject: [PATCH 2/4] YJIT: other_cb is None in tests

            Since the other cb is in CodegenGlobals, and we want Rust tests to be
            self-contained.
            ---
             yjit/src/asm/mod.rs | 1 +
             1 file changed, 1 insertion(+)

            Subject: [PATCH 3/4] YJIT: ARM64: Move functions out of arm64_emit()

            ---
             yjit/src/backend/arm64/mod.rs | 180 +++++++++++++++++-----------------
             1 file changed, 90 insertions(+), 90 deletions(-)

            Subject: [PATCH 4/4] YJIT: ARM64: Fix long jumps to labels

            Previously, with Code GC, YJIT panicked while trying to emit a B.cond
            instruction with an offset that is not encodable in 19 bits. This only
            happens when the code in an assembler instance straddles two pages.

            To fix this, when we detect that a jump to a label can land on a
            different page, we switch to a fresh new page and regenerate all the
            code in the assembler there. We still assume that no one assembler has
            so much code that it wouldn't fit inside a fresh new page.

            [Bug #19385]
            ---
             yjit/src/backend/arm64/mod.rs | 65 ++++++++++++++++++++++++++++++++---
             1 file changed, 60 insertions(+), 5 deletions(-)

commit f4e6e78410136100ef5f285136a66df8d6004a61
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-02-01 12:05:19 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-02-01 12:05:19 +0900

    Merge RubyGems 3.4.6 and Bundler 2.4.6 (#7214)

    Merge RubyGems-3.4.6 and Bundler-2.4.6

commit 40e0b1e123503805c16a2a9aafae0a5c302c20d1
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-31 23:46:50 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-31 23:46:50 +0900

    merge revision(s) 9726736006b3f74635fd8af05814fe0908e2cf84: [Backport #19327]

            Set STR_SHARED_ROOT flag on root of string

            ---
             string.c | 1 +
             1 file changed, 1 insertion(+)

commit 22bfad0ec9968be4c99c8c68f2c809b833069ea7
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-31 18:27:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-31 18:27:44 +0900

    Remove "Miscellaneous checks" from CI

    It is expected to use on master branch

commit ca75332f46c39804e06cd37c2608cbdef0aebf05
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-31 15:28:01 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-31 15:28:01 +0900

    merge revision(s) eccfc978fd6f65332eb70c9a46fbb4d5110bbe0a: [Backport #19379]

            Fix parsing of regexps that toggle extended mode on/off inside regexp

            This was broken in ec3542229b29ec93062e9d90e877ea29d3c19472. That commit
            didn't handle cases where extended mode was turned on/off inside the
            regexp.  There are two ways to turn extended mode on/off:

            ```
            /(?-x:#y)#z
            /x =~ '#y'

            /(?-x)#y(?x)#z
            /x =~ '#y'
            ```

            These can be nested inside the same regexp:

            ```
            /(?-x:(?x)#x
            (?-x)#y)#z
            /x =~ '#y'
            ```

            As you can probably imagine, this makes handling these regexps
            somewhat complex. Due to the nesting inside portions of regexps,
            the unassign_nonascii function needs to be recursive.  In
            recursive mode, it needs to track both opening and closing
            parentheses, similar to how it already tracked opening and
            closing brackets for character classes.

            When scanning the regexp and coming to `(?` not followed by `#`,
            scan for options, and use `x` and `i` to determine whether to
            turn on or off extended mode.  For `:`, indicting only the
            current regexp section should have the extended mode
            switched, recurse with the extended mode set or unset. For `)`,
            indicating the remainder of the regexp (or current regexp portion
            if already recursing) should turn extended mode on or off, just
            change the extended mode flag and keep scanning.

            While testing this, I noticed that `a`, `d`, and `u` are accepted
            as options, in addition to `i`, `m`, and `x`, but I can't see
            where those options are documented.  I'm not sure whether or not
            handling  `a`, `d`, and `u` as options is a bug.

            Fixes [Bug #19379]
            ---
             re.c                     | 153 +++++++++++++++++++++++++++++++++++++----------
             test/ruby/test_regexp.rb |  56 +++++++++++++++++
             2 files changed, 176 insertions(+), 33 deletions(-)

commit 5a2b28909ece2e1310250180f097bfcb7b0203dc
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-31 13:39:13 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-31 13:39:13 +0900

    merge revision(s) 3f54d09a5b8b6e4fd734abc8911e170d5967b5b0: [Backport #19390]

            bignum.c: rb_int_parse_cstr handle `0` strings

            [Bug #19390]

            We shouldn't check the string length when skipping zeros, as the
            string might only contains zero characters, resulting in an empty string.
            ---
             bignum.c               | 1 -
             test/ruby/test_time.rb | 4 ++++
             2 files changed, 4 insertions(+), 1 deletion(-)

commit 1689d8bb4843f92c1805e4a4bdd94049569198f4
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-31 11:08:50 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-31 11:08:50 +0900

    merge revision(s) 21dced8b01823a991829b66ffdc8ffc635965c76: [Backport #19389]

            [ruby/stringio] [Bug #19389] Fix chomping with longer separator

            https://github.com/ruby/stringio/commit/eb322a9716
            ---
             ext/stringio/stringio.c        | 5 +++--
             test/stringio/test_stringio.rb | 2 ++
             2 files changed, 5 insertions(+), 2 deletions(-)

commit a22eca82314ae36668d8c1a591ffbbfa8f93147c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-01-25 23:32:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-01-25 23:32:01 +0900

    Merge the latest stable versions of RubyGems and Bundler to Ruby 3.2.x (#7061)

    [Bug #19350]

    * Merge RubyGems-3.4.2 and Bundler-2.4.2

    * Merge RubyGems-3.4.3 and Bundler-2.4.3

    * Generate parser-text.rb of racc when sync it

    * Ignore LICENSE files of libraries vendored in rubygems [ci skip]

    * Adjust spec of bundler like as `sync_default_gems` [ci skip]

    * Fixed a typo

    * Removed vendored LICENSE file.

    * Update LEGAL sections for pub_grub

    * Merge RubyGems-3.4.4 and Bundler-2.4.4

    * Merge RubyGems-3.4.5 and Bundler-2.4.5

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit fee5b8f263211faef10ed9f3e43c1e8b34548bbd
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-25 16:34:24 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-25 16:34:24 +0900

    merge revision(s) 2c93c554019ebdc394d3c51c6d925620d3005f84,f5ea43a2e61789357e9c4b374b4bc6756abeae17: [Backport #19360]

            Ensure main file has default coverage if required. (#7169)

            * Extract common code for coverage setup.
            ---
             iseq.c | 13 +++++++++++--
             1 file changed, 11 insertions(+), 2 deletions(-)

            More coverage tests & specs. (#7171)

            * Add spec for eval and line coverage.

            * Add test for main file coverage.
            ---
             spec/ruby/library/coverage/start_spec.rb | 8 +++++++-
             test/coverage/autostart.rb               | 2 ++
             test/coverage/main.rb                    | 1 +
             test/coverage/test_coverage.rb           | 7 +++++++
             4 files changed, 17 insertions(+), 1 deletion(-)
             create mode 100644 test/coverage/autostart.rb
             create mode 100644 test/coverage/main.rb

commit 4110137fcfd805de03a8f5569c3d6926959b9363
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-25 13:26:25 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-25 13:26:25 +0900

    merge revision(s) 6f3aff3961a4c5ce87e05096a1a9dcf1055b7647: [Backport #19289]

            [Bug #19289] Retain `ruby_abi_version` function

            A few extension libraries, to hide all symbols except for necessary to
            load, hardcode the symbols to be exported in symbol list files for
            linker without even checking by `have_func`.  As a workaround for such
            libraries, retain `ruby_abi_version` symbol always even in released
            versions for now.
            ---
             include/ruby/internal/abi.h | 7 +++++--
             1 file changed, 5 insertions(+), 2 deletions(-)

commit 0090cb82b0bf477c29a659e34cf4427a3b1ceb27
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-25 10:23:38 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-25 10:23:38 +0900

    merge revision(s) df6b72b8ff7af16a56fa48f3b4abb1d8850f4d1c: [Backport #19348]

            Avoid checking interrupt when loading iseq
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            The interrupt check will unintentionally release the VM lock when loading an iseq.
            And this will cause issues with the `debug` gem's
            [`ObjectSpace.each_iseq` method](https://github.com/ruby/debug/blob/0fcfc28acae33ec1c08068fb7c33703cfa681fa7/ext/debug/iseq_collector.c#L61-L67),
            which wraps iseqs with a wrapper and exposes their internal states when they're actually not ready to be used.

            And when that happens, errors like this would occur and kill the `debug` gem's thread:

            ```
             DEBUGGER: ReaderThreadError: uninitialized InstructionSequence
            ┃ DEBUGGER: Disconnected.
            ┃ ["/opt/rubies/ruby-3.2.0/lib/ruby/gems/3.2.0/gems/debug-1.7.1/lib/debug/breakpoint.rb:247:in `absolute_path'",
            ┃  "/opt/rubies/ruby-3.2.0/lib/ruby/gems/3.2.0/gems/debug-1.7.1/lib/debug/breakpoint.rb:247:in `block in iterate_iseq'",
            ┃  "/opt/rubies/ruby-3.2.0/lib/ruby/gems/3.2.0/gems/debug-1.7.1/lib/debug/breakpoint.rb:246:in `each_iseq'",
            ...
            ```

            A way to reproduce the issue is to satisfy these conditions at the same time:

            1. `debug` gem calling `ObjectSpace.each_iseq` (e.g. [activating a `LineBreakpoint`](https://github.com/ruby/debug/blob/0fcfc28acae33ec1c08068fb7c33703cfa681fa7/lib/debug/breakpoint.rb#L246)).
            2. A large amount of iseq being loaded from another thread (possibly through the `bootsnap` gem).
            3. 1 and 2 iterating through the same iseq(s) at the same time.

            Because this issue requires external dependencies and a rather complicated timing setup to reproduce, I wasn't able to write a test case for it.
            But here's some pseudo code to help reproduce it:

            ```rb
            require "debug/session"

            Thread.new do
              100.times do
                ObjectSpace.each_iseq do |iseq|
                  iseq.absolute_path
                end
              end
            end

            sleep 0.1

            load_a_bunch_of_iseq
            possibly_through_bootsnap
            ```

            [Bug #19348]

            Co-authored-by: Peter Zhu <peter@peterzhu.ca>
            ---
             compile.c       |  2 +-
             vm_core.h       |  1 +
             vm_insnhelper.c | 11 +++++++++++
             3 files changed, 13 insertions(+), 1 deletion(-)

commit a20061cb1aa34b73bdbdfa7cba6cfc575a05ca38
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-24 17:41:17 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-24 17:41:35 +0900

    merge revision(s) 72eb33066fa9e7dacb7470cd140b219abe37667e: [Backport #19320]

            Fix off-by-one error in rb_vm_each_stack_value

            Applying the following patch to test/erb/test_erb.rb and running that
            file will cause Ruby to crash on my machine (macOS 13.1 on M1 Pro):

            ```
            --- a/test/erb/test_erb.rb
            +++ b/test/erb/test_erb.rb
            @@ -7,6 +7,12 @@
             class TestERB < Test::Unit::TestCase
               class MyError < RuntimeError ; end

            +  def setup
            +    GC.auto_compact = true
            +    GC.stress = true
            +    GC.verify_compaction_references(expand_heap: true, toward: :empty)
            +  end
            +
            ```

            It crashes with the following log:

            ```
            /Users/peter/src/ruby/lib/erb/compiler.rb:276: [BUG] Segmentation fault at 0x00000001083a8690
            ...
            -- C level backtrace information -------------------------------------------
            ...
            /Users/peter/src/ruby/build/ruby(rb_vm_each_stack_value+0xa8) [0x104cc3a44] ../vm.c:2737
            /Users/peter/src/ruby/build/ruby(rb_vm_each_stack_value+0xa8) [0x104cc3a44] ../vm.c:2737
            /Users/peter/src/ruby/build/ruby(check_stack_for_moved+0x2c) [0x104b272a4] ../gc.c:5512
            /Users/peter/src/ruby/build/ruby(gc_compact_finish) ../gc.c:5534
            /Users/peter/src/ruby/build/ruby(gc_sweep_compact) ../gc.c:8653
            /Users/peter/src/ruby/build/ruby(gc_sweep) ../gc.c:6196
            /Users/peter/src/ruby/build/ruby(has_sweeping_pages+0x0) [0x104b19c54] ../gc.c:9568
            /Users/peter/src/ruby/build/ruby(gc_rest) ../gc.c:9570
            ```

            This crash happens because it's reading the VALUE at sp. But since
            sp points to the top of the stack, it's reading the VALUE above the
            top of the stack, which is causing this segfault.

            Fixes [Bug #19320]
            ---
             vm.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit c0df0a85dec77a09308caddb1e1efd4d38fbf7b8
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-20 17:01:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-20 17:01:47 +0900

    merge revision(s) ed6fbb79e19bf401db0e85447fee955fd10a25c7: [Backport #19339]

            Fix crash when defining ivars on special constants

            [Bug #19339]
            ---
             test/ruby/test_variable.rb | 6 ++++++
             vm_insnhelper.c            | 5 +++++
             2 files changed, 11 insertions(+)

commit 373e62248c9dceb660e95f1cf05fa2a4a469cd64
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-20 12:24:24 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-20 12:24:24 +0900

    merge revision(s) f7b72462aa27716370c6bea1f2c240983aca9a55: [Backport #19356]

            String#bytesplice should return self

            In Feature #19314, we concluded that the return value of String#bytesplice
            should be changed from the source string to the receiver, because the source
            string is useless and confusing when extra arguments are added.

            This change should be included in Ruby 3.2.1.
            ---
             string.c                 | 4 ++--
             test/ruby/test_string.rb | 2 +-
             2 files changed, 3 insertions(+), 3 deletions(-)

commit 6a8fcb50210f8414d76968298576e39b9fa82562
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-19 21:52:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-19 21:52:47 +0900

    merge revision(s) 3be2acfafd3b3c6168e2266c7c6561d143d7ae5c: [Backport #19327]

            Fix re-embedding of strings during compaction

            The reference updating code for strings is not re-embedding strings
            because the code is incorrectly wrapped inside of a
            `if (STR_SHARED_P(obj))` clause. Shared strings can't be re-embedded
            so this ends up being a no-op. This means that strings can be moved to a
            large size pool during compaction, but won't be re-embedded, which would
            waste the space.
            ---
             gc.c                         | 16 +++++++++-------
             string.c                     | 12 ++++++++----
             test/ruby/test_gc_compact.rb |  8 ++++----
             3 files changed, 21 insertions(+), 15 deletions(-)

commit 98abe4a0be09e0571104f4ca1b5655e353910aa0
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-31 00:31:50 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-19 15:50:58 +0900

    Fix test when Ruby is verbose

    The test added in 90a80eb0 fails if Ruby is verbose, it outputs the
    following line to stderr:

        RUBY_GC_HEAP_INIT_SLOTS=100 (default value: 10000)

commit 686b38f83e70b3e1796092c71dd0b7dc2206b118
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-19 11:59:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-19 11:59:43 +0900

    merge revision(s) d8ef0a98c670449b20436947f5ebbd327ed5ab0d: [Backport #19319]

            [Bug #19319] Fix crash in rb_str_casemap

            The following code crashes on my machine:

            ```
            GC.stress = true

            str = "testing testing testing"

            puts str.capitalize
            ```

            We need to ensure that the object `buffer_anchor` remains on the stack
            so it does not get GC'd.
            ---
             string.c | 2 ++
             1 file changed, 2 insertions(+)

commit 1a2447ac9925e7794a7c5aa07960ad4de08e6aca
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-19 11:05:29 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-19 11:05:29 +0900

    merge revision(s) 979dd02e2f0a70f3f30d47c6115780d8fac6147e: [Backport #19262]

            Check if the argument is Thread::Backtrace::Location object

            [Bug #19262]
            ---
             ast.c                 | 5 +++++
             test/ruby/test_ast.rb | 6 ++++++
             2 files changed, 11 insertions(+)

commit 08ae7f64dc52c2b61e451d6e79ebdae73d482677
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-19 09:31:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-19 09:31:47 +0900

    merge revision(s) 273dca3aed7989120d57f80c789733d4bc870ffe: [Backport #19248]

            Fix undefined behavior in shape.c

            Under strict aliasing, writing to the memory location of a different
            type is not allowed and will result in undefined behavior. This was
            happening in shape.c due to `rb_id_table_lookup` writing to the memory
            location of `VALUE *` that was casted from a `rb_shape_t **`.

            This was causing test failures when compiled with LTO.

            Fixes [Bug #19248]

            Co-Authored-By: Alan Wu <alanwu@ruby-lang.org>
            ---
             shape.c | 13 +++++++++++--
             1 file changed, 11 insertions(+), 2 deletions(-)

commit d7fb4629b4058eb86be03760e6b9f1f272e44147
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-18 20:15:28 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-18 20:15:28 +0900

    merge revision(s) 837ef8911c638c3e2bdb6af710de7c1fac7b5f90: [Backport #19305]

            Fix crash in TracePoint c_call for removed method

            trace_arg->id is the ID of the original method of an aliased method. If
            the original method is removed, then the lookup will fail. We should use
            trace_arg->called_id instead, which is the ID of the aliased method.

            Fixes [Bug #19305]
            ---
             test/ruby/test_settracefunc.rb | 23 +++++++++++++++++++++++
             vm_trace.c                     |  2 +-
             2 files changed, 24 insertions(+), 1 deletion(-)

commit 44a3043d1182acf3147935d9c1564028b5538417
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-18 20:14:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-18 20:14:43 +0900

    merge revision(s) 2bbf63dd867fe3d349b1758805ad4421f2d772ab: [Backport #19298]

            Remove lib/mjit/instruction.rb

            This was accidentally re-introduced in f6620037ba1477d2c337d7b511f094d6d0fbb69c.

            [Bug #19298]
            ---
             lib/mjit/instruction.rb | 2162 -----------------------------------------------
             1 file changed, 2162 deletions(-)
             delete mode 100644 lib/mjit/instruction.rb

commit 1fb5eb5740d4c4f1fc34a4a50bc0482eac27b545
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-18 18:56:51 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-18 18:56:51 +0900

    merge revision(s) aeddc19340c7116d48fac3080553fbb823857d16: [Backport #19316]

            YJIT: Save PC and SP before calling leaf builtins (#7090)

            Previously, we did not update `cfp->sp` before calling the C function of
            ISEQs marked with `Primitive.attr! "inline"` (leaf builtins). This
            caused the GC to miss temporary values on the stack in case the function
            allocates and triggers a GC run. Right now, there is only a few leaf
            builtins in numeric.rb on Integer methods such as `Integer#~`. Since
            these methods only allocate when operating on big numbers, we missed
            this issue.

            Fix by saving PC and SP before calling the functions -- our usual
            protocol for calling C functions that may allocate on the GC heap.

            [Bug #19316]
            ---
             test/ruby/test_yjit.rb | 16 ++++++++++++++++
             yjit/src/codegen.rs    |  4 ++++
             2 files changed, 20 insertions(+)

commit f7e9b79f815e08e0a29fff11f77466f4ffb92520
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-18 18:56:09 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-18 18:56:09 +0900

    merge revision(s) 4959e01932cf6c4d3e5e90d3e0b4fa780f754fa6: [Backport #19271]

            common.mk: Do not invoke outdate-bundled-gems by default

            If baseruby is available (and its version is different from one being
            built) when compiling ruby, tool/outdate-bundled-gems.rb (which is
            invoked by `make install`) wrongly deletes debug.so and rbs_extension.so
            in .bundle/extension/*.

            This leads to a broken installation of ruby which lacks the libraries,
            which may make rubygems show the following warnings (in some additional
            complex conditions):

            ```
            $ irb
            Ignoring debug-1.7.1 because its extensions are not built. Try: gem pristine debug --version 1.7.1
            Ignoring rbs-2.8.2 because its extensions are not built. Try: gem pristine rbs --version 2.8.2
            irb(main):001:0>
            ```

            According to some committers, tool/outdate-bundled-gems.rb is introduced
            for fixing a build issue, but the detail is not recorded. The issue
            seems to occur only when debug gem or rbs gem is updated, so it is
            difficult to fix the script so soon.

            Tentatively, this change stops invoking the script by default.
            This should be backported to ruby_3_2.

            Fixes [Bug #19271]
            ---
             common.mk | 1 -
             1 file changed, 1 deletion(-)

commit 97c32b49e2fe4de8b57ce05146e63b2aa64c7a44
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-18 17:18:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-18 17:18:44 +0900

    merge revision(s) 43ff0c2c488c80aaf83b486d45bcd4a92ebe3848: [Backport #19299]

            YJIT: Fix `yield` into block with >=30 locals on ARM

            It's a register spill issue. Fix by moving the Qnil fill snippet to
            after registers are released.

            [Bug #19299]
            ---
             test/ruby/test_yjit.rb | 14 ++++++++++++++
             yjit/src/codegen.rs    | 29 ++++++++++++++---------------
             2 files changed, 28 insertions(+), 15 deletions(-)

commit 52ea5ea9906c3a96c60a68e01b303672602a6832
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-18 17:17:27 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-18 17:17:27 +0900

    merge revision(s) 291a4098cf649c027cb50c16b872455f26ad1dfb,5be0d42d2c4dc765230c76738289560f9ee37f09: [Backport #19296]

            Add missing assertion

            ---
             test/ruby/test_time.rb | 3 +++
             1 file changed, 3 insertions(+)

            [Bug #19296] Precheck bits of time components

            ---
             test/ruby/test_time.rb | 15 +++++++++++++++
             time.c                 | 14 ++++++++------
             2 files changed, 23 insertions(+), 6 deletions(-)

commit 057eff7663a0a4bc95a4799336a2bc14ca2480f0
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-18 17:08:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-18 17:08:23 +0900

    merge revision(s) eab7f4623fbf0488e828b75843d70c8e02dc8aa5: [Backport #19336]

            Return 0 if there is no CFP on the EC yet

            StackProf uses a signal handler to call `rb_profile_frames`.  Signals
            are delivered to threads randomly, and can be delivered after the thread
            has been created but before the CFP has been established on the EC.

            This commit returns early if there is no CFP to use.

            Here is some info from the core files we are seeing.  Here you can see
            the CFP on the current EC is 0x0:

            ```
            (gdb) p ruby_current_ec
            $20 = (struct rb_execution_context_struct *) 0x7f3481301b50
            (gdb) p ruby_current_ec->cfp
            $21 = (rb_control_frame_t *) 0x0
            ```

            Here is where VM_FRAME_CFRAME_P gets a 0x0 CFP:

            ```
            6  VM_FRAME_CFRAME_P (cfp=0x0) at vm_core.h:1350
            7  VM_FRAME_RUBYFRAME_P (cfp=<optimized out>) at vm_core.h:1350
            8  rb_profile_frames (start=0, limit=2048, buff=0x7f3493809590, lines=0x7f349380d590) at vm_backtrace.c:1587
            ```

            Down the stack we can see this is happening after thread creation:

            ```
            19 0x00007f3495bf9420 in <signal handler called> () at /lib/x86_64-linux-gnu/libpthread.so.0
            20 0x000055d531574e55 in thread_start_func_2 (th=<optimized out>, stack_start=<optimized out>) at thread.c:676
            21 0x000055d531575b31 in thread_start_func_1 (th_ptr=<optimized out>) at thread_pthread.c:1170
            22 0x00007f3495bed609 in start_thread (arg=<optimized out>) at pthread_create.c:477
            23 0x00007f3495b12133 in clone () at ../sysdeps/unix/sysv/linux/x86_64/clone.S:95
            ```
            ---
             vm_backtrace.c | 9 +++++++++
             1 file changed, 9 insertions(+)

commit 89cd61890fe78e0491708f87a5df678b03fda8a3
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-17 11:21:00 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-17 11:21:00 +0900

    merge revision(s) 542e984d82fa25098eb15398d716d907acc52b93: [Backport #19292]

            [Bug #19292] Re-initialize tm when wday or yday is not set

            ---
             test/ruby/test_time.rb |  3 ++-
             time.c                 | 31 ++++++++++++++++++++++---------
             2 files changed, 24 insertions(+), 10 deletions(-)

commit 49cf0896a2934547c0764aadaec021fb37a2e96f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-01-17 11:20:40 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-01-17 11:20:40 +0900

    merge revision(s) 90a80eb076429978e720e11fb17a3cbb96de3454: [Backport #19284]

            Fix integer underflow when using HEAP_INIT_SLOTS

            There is an integer underflow when the environment variable
            RUBY_GC_HEAP_INIT_SLOTS is less than the number of slots currently
            in the Ruby heap.

            [Bug #19284]
            ---
             gc.c                 | 25 +++++++++++++------------
             test/ruby/test_gc.rb |  5 +++++
             2 files changed, 18 insertions(+), 12 deletions(-)

commit a7d467a792c644a7260d6560ea2002fdb8ff6de3
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-12-29 15:59:52 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-12-29 15:59:52 +0900

    merge revision(s) b726d60c986bf951d13e7a2ab5f5e58f58657b03: [Backport #19273]

            Fix [Bug 19273], set correct value to `outer_repeat` on `OP_REPEAT`
             (#7035)

            ---
             regexec.c                | 2 +-
             test/ruby/test_regexp.rb | 5 +++++
             2 files changed, 6 insertions(+), 1 deletion(-)

commit 5c551ac59f9620901394a46dffda5a1833b9c4b0
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-12-27 14:56:51 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-12-27 14:56:51 +0900

    merge revision(s) fc03ba50f1ff6c30f7c654f564b4dffbed0844ef: [Backport #19263]

            MJIT: Fix JIT code for multiple values in a single case

            [Bug #19263]
            ---
             lib/ruby_vm/mjit/compiler.rb |  2 +-
             test/ruby/test_mjit.rb       | 10 ++++++++++
             2 files changed, 11 insertions(+), 1 deletion(-)

commit a528908271c678360d2d8ca232c178e7cdd340b4
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-12-25 15:55:25 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-12-25 15:55:25 +0900

    v3.2.0

commit 07c19cf551e58e1b82af5efeb0047f10588fff9f
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2022-12-25 13:30:43 +0900
  Commit:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  CommitDate: 2022-12-25 13:30:43 +0900

    Fix a grammar [ci skip]

commit be7cb324a59f523e8e4a3d2bbb7c92f3fa6a84fd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-25 12:18:53 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-25 12:19:23 +0900

    Clean yjit directory in build directory [ci skip]

commit 82b8805eb4a7995baf1e15dd5810fce9101826bd
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-25 05:56:10 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-25 05:56:10 +0900

    Update default gems list at 8f05e4f54bdb3bcf05574bd5f12e56 [ci skip]

commit 8f05e4f54bdb3bcf05574bd5f12e56f7e010c8a2
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-25 04:42:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-25 05:55:36 +0900

    Update Bundler to 2.4.1 & and RubyGems to 3.4.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7020

commit 3cbe37bd357464c0ce665770998b691cad022a24
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-25 00:43:27 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-25 00:43:27 +0900

    Support new style diagnostic reports

commit 4378de02f9c2c494ae1302c59625e2d126b23f3e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-24 11:21:28 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-24 23:49:27 +0900

    Test of environment variables order for HOME on Windows

commit d0f5dc9eac78ecade459b740ed08795c8df6d129
  Author:     Lars Kanis <lars@greiz-reinsdorf.de>
  AuthorDate: 2022-12-19 05:05:54 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-24 23:48:47 +0900

    Windows: Prefer USERPROFILE over HOMEPATH

    HOMEPATH is set to "\WINDOWS\system32" when running per "runas" session.
    This directory is not writable by ordinary users, leading to errors with many ruby tools.
    Also config files in the home directory are not recognized.

    Still keeping HOME at first which is not used by native Windows,
    but by ruby specs and by MSYS2 environment.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6992

commit 6a55b4601a50144a4c98571a79395b85465fda7f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 18:55:29 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-24 22:55:12 +0900

    Add Dir.home test with encoding

commit d6ce4180a5b4dacbac895c9911031a6df6c61136
  Author:     Lars Kanis <lars@greiz-reinsdorf.de>
  AuthorDate: 2022-12-19 05:05:22 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-24 22:54:23 +0900

    Windows: Fix encoding of Dir.home

    Dir.home returns an UTF-8 string since ruby-3.0, but the actual
    encoding of the bytes was CP_ACP or CP_OEMCP.
    That led to invalid bytes when calling Dir.home with an unicode
    username.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6991

commit 18c1ca8f4c0748905d5cedb6c044df507ea8ad6a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-24 20:18:10 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-24 20:18:10 +0900

    Fix test-syntax-suggest order

    Prepare for test-syntax-suggest after other tests finished.

commit 3fb1d49a1f1289142f3da8e876133bd7f459e4f6
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-12-24 18:59:45 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-12-24 18:59:45 +0900

    Revert "darwin: resolve rb symbols from ext by `-flat_namespace` to see libruby transitively"

    This reverts commit c5eefb7f37db2865891298dd1a1e60dff09560ad.

    Flat namespace breaks gems with C extention if its symbols conflict
    with ohter libraries.

commit b9332ac8e7126066ac4238443d63eaa4c06789f9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-24 18:13:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-24 18:13:40 +0900

    MJIT: Cancel all on disastrous situations (#7019)

    I noticed this while running test_yjit with --mjit-call-threshold=1,
    which redefines `Integer#<`. When Ruby is monkey-patched,
    MJIT itself could be broken.

    Similarly, Ruby scripts could break MJIT in many different ways. I
    prepared the same set of hooks as YJIT so that we could possibly
    override it and disable it on those moments. Every constant under
    RubyVM::MJIT is private and thus it's an unsupported behavior though.

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit d521c9e5a7ed603f8f1aaa9a9a66c3cc80599b0c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-24 17:54:21 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-24 17:54:21 +0900

    cosmetic changes for external link

commit 8263feaa22bce11f173c53305bcd43eb702cc5fc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-24 17:20:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-24 17:20:09 +0900

    Added some of new features for RubyGems 3.4 and Bundler 2.4

commit 03e030d463774744ee6bc90195ca59476f9a8b81
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-24 16:57:38 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-24 16:57:38 +0900

    Update default gems list at f6620037ba1477d2c337d7b511f094 [ci skip]

commit f6620037ba1477d2c337d7b511f094d6d0fbb69c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-22 08:20:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-24 16:57:07 +0900

    Merge RubyGems-3.4.0 and Bundler-2.4.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6987

commit d5635dfe36588b04d3dd6065ab4e422f51629b11
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-24 11:27:35 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-24 11:29:11 +0900

    Extract setup of environment variables

commit 640dca9ae72e55028af812cc041bdaed1f5a2af4
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-23 06:29:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-24 10:52:20 +0900

    [DOC] Document AST.parse's keyword arguments

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6996

commit c3c116f6a6b92d0224b35e7423959a7ab39ddc6b
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2022-12-24 07:48:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-24 07:48:58 +0900

    [DOC] Document new methods of IO::Buffer and Fiber::Scheduler (#7016)

    Co-authored-by: Samuel Williams <samuel.williams@oriontransfer.co.nz>

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 11ad9a42d76ba785b2ec93f327469ead9b810ef4
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2022-12-24 03:52:10 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-24 03:52:10 +0900

    Fix missing handling of offset argument in `IO::Buffer` `pread` and `pwrite`. (#7012)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit af4cd997a160c4eddc935dd384dbd0160d3160ce
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-20 01:20:21 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-24 03:19:45 +0900

    sample/trick2022/03-mame/entry.rb: remove trailing spaces

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7014

commit a8485291bbdbe3b8e867f59d2d77b7a22732e5a6
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-19 22:32:48 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-24 03:19:45 +0900

    test/test_trick.rb: Add tests for TRICK 2022 entries

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7014

commit e8b0180974a1f51ae3894d3e055461a1037c778d
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-19 22:12:34 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-24 03:19:45 +0900

    sample/trick2022/: adds the top-three entries of TRICK 2022

    See https://github.com/tric/trick2022 for TRICK 2022.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7014

commit 1d3bfd804cdba027ab9ec79678692b607c43b798
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-24 03:18:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-24 03:18:57 +0900

    MJIT: Export fewer shape functions (#7007)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit ee60756495b775c4e8fc93a57094ac4e4b83fa7f
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2022-12-24 02:24:55 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-24 02:24:55 +0900

    Fix backtrace beyond _singtramp on macOS arm64 (#7015)

    * move ptrauth_strip logic into vm_dump.c
    * don't use _sigtramp special logic on arm64

  Notes:
    Merged-By: nurse <naruse@airemix.jp>

commit 1876cda972ea226ee85faf14dae6d047e145a4c6
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-23 23:42:18 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-24 01:21:14 +0900

    Add tests for compacting shared arrays

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7013

commit 7891f9407184ca6b4636092555d2546e3830c2ff
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-23 23:33:51 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-24 01:21:14 +0900

    Don't allow re-embedding frozen arrays

    Frozen arrays should not move from heap allocated to embedded because
    frozen arrays could be shared roots for other (shared) arrays. If the
    frozen array moves from heap allocated to embedded it would cause issues
    since the shared array would no longer know where to set the pointer
    in the shared root.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7013

commit d61a4cec618b8f5554398fff2ee4656763aeec4e
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-22 05:33:48 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-24 01:09:49 +0900

    Docs: path: option for IO.new

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6985

commit c621c6140ad8ace766e616f593f530041d860a23
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-22 05:10:21 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-24 01:09:49 +0900

    Docs: Fix problems with Fiber's docs

    * References to Scheduler (was outdated to SchedulerInterface)
    * References between new methods (storage, [], []=)
    * Storage's call-sequence (rendered confusingly)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6985

commit 5c04ff944ee6bdfb1c20acef20b7b0b1d5074440
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-22 04:52:55 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-24 01:09:49 +0900

    Docs: Fix small glitch in GC

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6985

commit 64cdf1936a3952fbd43083de55244dd1b701cce6
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-22 04:51:08 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-24 01:09:49 +0900

    Docs: Separate documentation for UnboundMethod#==

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6985

commit b3d57fdd64d2e88499bf718e64522dfce9358c48
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-22 04:23:14 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-24 01:09:49 +0900

    Docs: Update Struct docs about keyword initialization

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6985

commit 91076b2c595a83fd55b49f907b2f9d84d264e5a2
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-22 04:22:38 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-24 01:09:49 +0900

    Docs: Fix rendering of SyntaxError#path

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6985

commit 65920cfc40b47e9e037e0536b2b7de8f0cf30fc3
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-19 17:15:31 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-23 23:48:18 +0900

    addr2line.c: Strip pointer authentication

    We need to manually strip pointer authentication bits on M1 mac because
    libunwind leaks them out.

    Co-Authored-By: NARUSE, Yui <naruse@airemix.jp>
    Co-Authored-By: Yuta Saito <kateinoigakukun@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7011

commit 97280faf2818cc464e1ef9e898807c60a2726bf8
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-22 01:32:09 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-23 23:46:37 +0900

    Add blog post on VWA to NEWS.md [ci skip]

    The link currently 404s but the blog post will be published on Dec 25.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6979

commit 540b67da4d59ab7d9dbba8d5551944dad1ef8200
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 12:57:31 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-23 20:33:27 +0900

    test-syntax-suggest is run by check now

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7010

commit cae53842735237ccf71a13873fd0d1ae7f165582
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 12:02:31 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-23 20:33:27 +0900

    Test syntax_suggest by `make check`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7010

commit 17b63ab6b1a8b9f5af99d3bcdb95a3bb19fdd576
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 20:27:58 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-23 20:31:25 +0900

    [ruby/rdoc] Fix fragile tests

    When the temporary path is long enough, the formatter may fold the
    path and may hit a hyphen at the end of line, and miscounted.

    https://github.com/ruby/rdoc/commit/5f46479543

commit edb83dc3a2c374e880e8eb488152872152790e92
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-23 19:37:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 19:37:24 +0900

    Revert the additional change from openssl-3.1.0

      Revert "[ruby/openssl] pkey/ec: constify"

      This reverts commit d2cd903c85f38f42c6aefc6d97a1558f74d8d9db.

commit eb8d4d7b5145849325985c00b810b8d75661d86e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-23 19:36:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 19:36:43 +0900

    Revert the additional changes from net-http-0.3.2

commit d40064d1846b5835dff81e3f168c0c3a6c85e814
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-23 19:32:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 19:33:27 +0900

    Revert the accidentally commit from erb-4.0.2

      Revert "[ruby/erb] Use a ruby-lang alias on spec.email"

      This reverts commit fa64889abbad727d31bb927604d87679825dcd37.

commit c5eefb7f37db2865891298dd1a1e60dff09560ad
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2022-12-23 13:58:45 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2022-12-23 17:45:20 +0900

    darwin: resolve rb symbols from ext by `-flat_namespace` to see libruby transitively

    This repairs the assumption, which many fat-gem maintainer expect, "An
    extension built with --disable-shared Ruby is loadable from
    --enable-shared Ruby".

    By default all references resolved to a dynamic library use "two-level
    namespace", which record the library name and symbol name for each
    resolution entry. On the other hand, `-flat_namespace` discards the
    library name information and resolves symbols "flatly".
    This behavior is useful for us to ignore which image (`ruby`
    executable or `libruby.dylib`) provides rb symbols at runtime.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7008

commit 9c1f03a38a2650a10c24433663eaf46e8dcfab59
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 16:55:50 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-23 16:57:15 +0900

    Debug for zlinux CI [ci skip]

commit 970b26fb713205ad663467ede98cb18fb640763e
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2022-12-23 15:29:33 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2022-12-23 15:30:59 +0900

    NEWS.md: add 2 functions for debuggers [ci skip]

commit 0d75d403ab257eb8d4052a193081db68df37eb47
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-23 14:49:37 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-23 14:49:37 +0900

    Update bundled gems list at 2192f2e6bc361396f6a81ead955a0d [ci skip]

commit 2192f2e6bc361396f6a81ead955a0de31a2e164c
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2022-12-23 14:48:35 +0900
  Commit:     Shugo Maeda <shugo@ruby-lang.org>
  CommitDate: 2022-12-23 14:48:35 +0900

    Update bundled_gems for net-imap

commit 4aeea3cc09b302862fd0d40ccfaf86a688681d82
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-23 13:10:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 14:07:02 +0900

    Removed the needless test guard for syntax_suggest.

      It's resolved by https://github.com/ruby/ruby/commit/5bb43aeb890657ea586e3fabbf763e5b5670ffd7

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7006

commit bf3b376522705eaa01204618a15fce4c11dde42b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 12:29:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 13:05:26 +0900

    [ruby/syntax_suggest] Remove debug print

    https://github.com/ruby/syntax_suggest/commit/4d53d31bc5

commit 5bb43aeb890657ea586e3fabbf763e5b5670ffd7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 12:28:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 13:05:25 +0900

    [ruby/syntax_suggest] Should not hardcode ruby name

    https://github.com/ruby/syntax_suggest/commit/0d5201b24d

commit 4d05a96d14221ab2855c2d0795d1a70216c70b75
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-23 11:47:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 12:54:36 +0900

    Bump actions/checkout from 3.1.0 to 3.2.0

    Bumps [actions/checkout](https://github.com/actions/checkout) from 3.1.0 to 3.2.0.
    - [Release notes](https://github.com/actions/checkout/releases)
    - [Changelog](https://github.com/actions/checkout/blob/main/CHANGELOG.md)
    - [Commits](https://github.com/actions/checkout/compare/93ea575cb5d8a053eaa0ac8fa3b40d7e05a33cc8...755da8c3cf115ac066823e79a1e1788f8940201b)

    ---
    updated-dependencies:
    - dependency-name: actions/checkout
      dependency-type: direct:production
      update-type: version-update:semver-minor
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7003

commit cc35d3ccb73c4badd4f2376e41ea0ef735484149
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-23 08:22:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 11:47:20 +0900

    Bump actions/cache from 3.0.11 to 3.2.0

    Bumps [actions/cache](https://github.com/actions/cache) from 3.0.11 to 3.2.0.
    - [Release notes](https://github.com/actions/cache/releases)
    - [Changelog](https://github.com/actions/cache/blob/main/RELEASES.md)
    - [Commits](https://github.com/actions/cache/compare/9b0c1fce7a93df8e3bb8926b0d6e9d89e92f20a7...c17f4bf4666a8001b1a45c09eb7a485c41aa64c3)

    ---
    updated-dependencies:
    - dependency-name: actions/cache
      dependency-type: direct:production
      update-type: version-update:semver-minor
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7000

commit d2cd903c85f38f42c6aefc6d97a1558f74d8d9db
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 11:18:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-23 11:42:15 +0900

    [ruby/openssl] pkey/ec: constify

    https://github.com/ruby/openssl/commit/6fb3499a7b

commit d2847009dbe1df52b3984ab994b1d5c2dadbb86e
  Author:     Marco Costa <mmarcottulio@gmail.com>
  AuthorDate: 2022-12-23 11:12:16 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-23 11:12:16 +0900

    [DOC] Fix most of Range#cover? marked as verbatim

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7005

    Merged-By: nobu <nobu@ruby-lang.org>

commit 792c50e917c6f7a7ed0f3ca8c64b47c005593b41
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 10:46:25 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-23 11:05:09 +0900

    [ruby/rdoc] Clean up home directories for each test

    https://github.com/ruby/rdoc/commit/f067c174da

commit def8ad4072dfdf2c267b31e72a7f7fb7b9472dd2
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-23 08:21:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 10:21:36 +0900

    Bump octokit/request-action

    Bumps [octokit/request-action](https://github.com/octokit/request-action) from 52ce92ce3185e00e2425f043c3e9509121929aea to 8cd8f5d6738d122de9213dc5cf87e116c40f5fae.
    - [Release notes](https://github.com/octokit/request-action/releases)
    - [Commits](https://github.com/octokit/request-action/compare/52ce92ce3185e00e2425f043c3e9509121929aea...8cd8f5d6738d122de9213dc5cf87e116c40f5fae)

    ---
    updated-dependencies:
    - dependency-name: octokit/request-action
      dependency-type: direct:production
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6997

commit 9c4472935bd83582e676b3432d68fa3aa1e571a5
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-23 08:22:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 10:13:17 +0900

    Bump github/codeql-action from 2.1.35 to 2.1.37

    Bumps [github/codeql-action](https://github.com/github/codeql-action) from 2.1.35 to 2.1.37.
    - [Release notes](https://github.com/github/codeql-action/releases)
    - [Changelog](https://github.com/github/codeql-action/blob/main/CHANGELOG.md)
    - [Commits](https://github.com/github/codeql-action/compare/b2a92eb56d8cb930006a1c6ed86b0782dd8a4297...959cbb7472c4d4ad70cdfe6f4976053fe48ab394)

    ---
    updated-dependencies:
    - dependency-name: github/codeql-action
      dependency-type: direct:production
      update-type: version-update:semver-patch
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7001

commit fe2c996adbd56f7892f214f7f39d910a00d5b937
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-23 10:01:00 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-23 10:01:00 +0900

    Update default gems list at 2fb6b391423fbefc4a542765727a48 [ci skip]

commit 2fb6b391423fbefc4a542765727a4844c618e430
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-23 08:21:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 10:00:14 +0900

    Bump ruby/setup-ruby from 1.126.0 to 1.128.0

    Bumps [ruby/setup-ruby](https://github.com/ruby/setup-ruby) from 1.126.0 to 1.128.0.
    - [Release notes](https://github.com/ruby/setup-ruby/releases)
    - [Commits](https://github.com/ruby/setup-ruby/compare/c7079efafd956afb5d823e8999c2506e1053aefa...4b2d1d631efa087f8896c15a0c6023dc2f483198)

    ---
    updated-dependencies:
    - dependency-name: ruby/setup-ruby
      dependency-type: direct:production
      update-type: version-update:semver-minor
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6999

commit 5507b32d192cce2b5cb508a79119197146b3e4cb
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-23 09:52:44 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-23 09:52:44 +0900

    Update default gems list at 2d2baaf2f46d447f64f4f8fd7cfa3a [ci skip]

commit 3ade713967de46665c3682af5696fd3b8dac1d86
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-23 09:42:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 09:51:52 +0900

    Bump version to 1.6.2

commit ba342088009619f5df84116a0567e93bf6c9181b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-23 09:11:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 09:51:35 +0900

    Bump up Racc parser version

commit 6438f3cad684fc3ab5d4cd9950a01eabbfdfd289
  Author:     Johnny Willemsen <jwillemsen@remedy.nl>
  AuthorDate: 2022-12-21 03:44:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 09:46:59 +0900

    [ruby/racc] Removed old originalId in comment

    https://github.com/ruby/racc/commit/1dfbef8e99

commit 2d2baaf2f46d447f64f4f8fd7cfa3a2a7eba69ed
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-12-23 08:52:24 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] Ruby/OpenSSL 3.1.0

    https://github.com/ruby/openssl/commit/c2f7d775c6

commit a77830591919f06feaeb82585c229322d5e8836b
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-12-23 08:49:36 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] Ruby/OpenSSL 3.0.2

    https://github.com/ruby/openssl/commit/48b79333e0

commit 046aadb89b62d5ca5b8a0a061e5682f82defa22d
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-12-23 08:40:26 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] Ruby/OpenSSL 2.2.3

    https://github.com/ruby/openssl/commit/04acccd692

commit 75e7b85e3ec0b9724cce585d31c2c3c5aaa6a9a0
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-12-23 06:04:20 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] test/openssl/test_pkey.rb: allow failures in test_s_generate_parameters

    The root cause has been fixed by OpenSSL 3.0.6, but Ubuntu 22.04's
    OpenSSL package has not backported the patch yet.

    Reference: https://github.com/ruby/openssl/issues/492

    https://github.com/ruby/openssl/commit/f2e2a5e5ed

commit 0e11d2c3f8a74d2310efa67179b50c12acb3fa42
  Author:     Joe Truba <joe@bannable.net>
  AuthorDate: 2022-11-20 09:54:32 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] pkey/ec: check private key validity with OpenSSL 3

    The behavior of EVP_PKEY_public_check changed between OpenSSL 1.1.1
    and 3.0 so that it no longer validates the private key. Instead, private
    keys can be validated through EVP_PKEY_private_check and
    EVP_PKEY_pairwise_check.

    [ky: simplified condition to use either EVP_PKEY_check() or
    EVP_PKEY_public_check().]

    https://github.com/ruby/openssl/commit/e38a63ab3d

commit 782777a803f990f688579db50c938d1a80a5f24a
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2022-10-31 20:07:57 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] Undefine `OpenSSL::SSL` for no socket platforms

    This fixes a linkage error about `ossl_ssl_type` on platforms which do
    not have socket, like WASI.

    Even before this patch, some items are disabled under `OPENSSL_NO_SOCK` since
    https://github.com/ruby/ruby/commit/ee22fad45d394818690c4a7586d7bb576ba67c56
    However, due to some new use of OpenSSL::SSL::Socket over the past few years,
    the build under `OPENSSL_NO_SOCK` had been broken.

    This patch guards whole `OpenSSL::SSL` items by `OPENSSL_NO_SOCK`.

    [ky: adjusted to apply on top of my previous commit that removed the
    OpenSSL::ExtConfig, and added a guard to lib/openssl/ssl.rb.]

    https://github.com/ruby/openssl/commit/b0cfac6a96

commit e6ca6443299b48f906662b438e5267d876d21a1e
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-12-23 04:34:43 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] ssl: remove OpenSSL::ExtConfig

    This module was introduced in 2015 for internal use within this library.
    Neither of the two constants in it is used anymore. I don't think we
    will be adding a new constant in the foreseeable future, either.

    OPENSSL_NO_SOCK is unused since commit https://github.com/ruby/openssl/commit/998d66712a78 (r55191).
    HAVE_TLSEXT_HOST_NAME is unused since commit https://github.com/ruby/openssl/commit/4eb4b3297a92.

    https://github.com/ruby/openssl/commit/eed3894bda

commit a4b4997c69437e9d2ba09629d72284a4fb9defc5
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-12-23 04:06:12 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] test/openssl/test_ssl.rb: do not run SSL tests if not available

    https://github.com/ruby/openssl/commit/a3d230d4e0

commit dd6f3276e07f8f731a3bbcbdd58525ee6dd6581e
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-10-17 17:33:37 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] ssl: disable NPN support on LibreSSL

    As noted in commit https://github.com/ruby/openssl/commit/a2ed156cc9f1 ("test/test_ssl: do not run NPN tests
    for LibreSSL >= 2.6.1", 2017-08-13), NPN is known not to work properly
    on LibreSSL.

    Disable NPN support on LibreSSL, whether OPENSSL_NO_NEXTPROTONEG is
    defined or not.

    NPN is less relevant today anyway. Let's also silence test suite when
    it's not available.

    https://github.com/ruby/openssl/commit/289f6e0e1f

commit d6c16dd3e67ea5aa58a2f17dc8aa8aa977ded99a
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-10-17 16:52:46 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] ssl: update TLS1_3_VERSION workaround for older LibreSSL versions

    The macro is now defined by default in LibreSSL 3.4+. Let's document it
    for future readers.

    https://github.com/ruby/openssl/commit/935698e9f9

commit 7c073cc11221eb85ac0c55ec38ff4c9da22ca26c
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-10-17 16:50:10 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] test/openssl/test_asn1.rb: remove pend for unsupported LibreSSL versions

    Commit https://github.com/ruby/openssl/commit/af895bc5596b ("asn1: avoid truncating OID in
    OpenSSL::ASN1::ObjectId#oid", 2016-12-15) added this test case.

    The OBJ_obj2txt() issue was fixed by LibreSSL 2.5.1 (released in 2017)
    and is no longer relevant today.

    https://github.com/ruby/openssl/commit/6a188f1a29

commit 5591e4935da7b606f9d3047894eeea5d7e4a8864
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-10-17 16:50:01 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] test/openssl/test_asn1.rb: skip failing tests on LibreSSL 3.6.0

    LibreSSL 3.6.0 expects the seconds part in UTCTime and GeneralizedTime
    to be always present. LibreSSL 3.6.0 release note [1] says:

    > - The ASN.1 time parser has been refactored and rewritten using CBS.
    >   It has been made stricter in that it now enforces the rules from
    >   RFC 5280.

    [1] https://ftp.openbsd.org/pub/OpenBSD/LibreSSL/libressl-3.6.0-relnotes.txt

    https://github.com/ruby/openssl/commit/bbc540fe83

commit 6df4d272c3f74d3f9d206536add39b59ee1acb57
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-07-10 00:15:46 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] Suppress deprecation warnings by OpenSSL 3

    https://github.com/ruby/openssl/commit/91657a7924

commit d7d1bb3e871108b787d67da1f0d11d317bdfacf7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-07-09 00:17:25 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:15 +0900

    [ruby/openssl] Constify when building with OpenSSL 3

    https://github.com/ruby/openssl/commit/c0023822fe

commit 2bc7eac8224d3a58381505d5296652594159017c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-07-09 23:32:44 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:14 +0900

    [ruby/openssl] Check for functions with arguments

    https://github.com/ruby/openssl/commit/b67aaf925d

commit ca7a6b15535f23b624452ab793d60ee277d8c73f
  Author:     Joe Truba <joe@bannable.net>
  AuthorDate: 2022-11-26 07:30:01 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:14 +0900

    [ruby/openssl] pkey/ec: fix ossl_raise() calls using cEC_POINT instead of eEC_POINT

    https://github.com/ruby/openssl/commit/b2e9f5e132

commit 13137236dc34e80402489de226d3671c87a24686
  Author:     Joe Truba <joe@bannable.net>
  AuthorDate: 2022-11-20 06:46:49 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2022-12-23 09:39:14 +0900

    [ruby/openssl] raise when EC_POINT_cmp or EC_GROUP_cmp error instead of returning true

    https://github.com/ruby/openssl/commit/e1e8f3cebe

commit f17448e8c3bebb724bbe5083fb7e55c17659d237
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-23 09:35:50 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-23 09:35:50 +0900

    Update bundled gems list at fe2bcd352899cd402091c2815846d1 [ci skip]

commit fe2bcd352899cd402091c2815846d17a0eb1369b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 09:33:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 09:35:07 +0900

    Check `added` for the second sub! properly

    Even if the first sub! modifies `news`, when `added` is empty, it always
    ended up skipping `File.write("NEWS.md", news)` because of the `next`.
    This commit fixes the problem.

commit 31b29aad27013da64934e4af1aaa8c2be70f02b8
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-23 08:21:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-23 09:32:22 +0900

    Bump ossf/scorecard-action from 2.0.6 to 2.1.2

    Bumps [ossf/scorecard-action](https://github.com/ossf/scorecard-action) from 2.0.6 to 2.1.2.
    - [Release notes](https://github.com/ossf/scorecard-action/releases)
    - [Changelog](https://github.com/ossf/scorecard-action/blob/main/RELEASE.md)
    - [Commits](https://github.com/ossf/scorecard-action/compare/99c53751e09b9529366343771cc321ec74e9bd3d...e38b1902ae4f44df626f11ba0734b14fb91f8f86)

    ---
    updated-dependencies:
    - dependency-name: ossf/scorecard-action
      dependency-type: direct:production
      update-type: version-update:semver-minor
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6998

commit 7d700a9f5df32718a9376d53e023a5a9787c0afa
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2022-12-23 03:13:24 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2022-12-23 08:32:57 +0900

    debug.gem v1.7.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6995

commit 6ae4fe2ba627bf4975a9a23b000f41ca8a5b8bb6
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-23 08:23:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-23 08:23:14 +0900

    Bump necojackarc/auto-request-review from 0.8.0 to 0.10.0 (#7002)

    Bumps [necojackarc/auto-request-review](https://github.com/necojackarc/auto-request-review) from 0.8.0 to 0.10.0.
    - [Release notes](https://github.com/necojackarc/auto-request-review/releases)
    - [Commits](https://github.com/necojackarc/auto-request-review/compare/b5e81876454003a4ccb9b89cb205c67d77d7035b...5f91f424cabb3211c669e49e79da8363f7df395b)

    ---
    updated-dependencies:
    - dependency-name: necojackarc/auto-request-review
      dependency-type: direct:production
      update-type: version-update:semver-minor
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

    Signed-off-by: dependabot[bot] <support@github.com>
    Co-authored-by: dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit c566c968f96ba02e7e775c88b5cbb150fb3839e9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 08:03:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 08:06:37 +0900

    Hide RubyVM::Shape's interface as much as possible [ci skip]

    RubyVM::Shape is usually not available (you need SHAPE_DEBUG macro,
    which is not defined by default). So it seems confusing to leave
    RubyVM::Shape in the document.

    This hides only method definitions because, well, I can't find a way to
    hide things defined by rb_define_const or rb_struct_define_under. I gave
    up making the C-based documentation right. You should define things in
    Ruby instead.

commit 033e19dabfff1e867c4c1f9997f6d4631c83d1ee
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 07:43:58 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 07:43:58 +0900

    Document the public interface of YJIT [ci skip]

commit 0b2aea861cde3c001e59eafb19f4fa1fa615a5a5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 07:30:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 07:30:09 +0900

    Polish the public docs for MJIT [ci skip]

    Now every private interface is cleaned up, and the public interface is
    documented.

commit cce6a30fddd08efcc435fd28cef27b4731817efa
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 06:39:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 06:39:08 +0900

    Avoid calling it a stdlib [ci skip]

    It technically is, but it's probably just confusing for most people.

commit dc8c5bafcf3afe478710a8f93b8638fcbf510f1f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-23 06:06:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-23 06:06:31 +0900

    Clean intermediate source file in `TestMJIT#test_jit_failure` (#6994)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 7e8fa06022a9e412e3f8e6c8b6f0ba1909f648d5
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2022-12-21 05:44:11 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2022-12-23 04:50:26 +0900

    Always issue deprecation warning when calling Regexp.new with 3rd positional argument

    Previously, only certain values of the 3rd argument triggered a
    deprecation warning.

    First step for fix for bug #18797.  Support for the 3rd argument
    will be removed after the release of Ruby 3.2.

    Fix minor fallout discovered by the tests.

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6976

commit 9dcee2d80ee995e11b0fd437d4a94930ccb6db67
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 04:35:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 04:35:46 +0900

    Remove MJIT's private constants from docs [ci skip]

commit ad1ce2b7b6034688bfb171b6fbc54bc9e3ffa54c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 04:17:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 04:17:25 +0900

    Remove mjit.md from public documentation [ci skip]

    It's for CRuby developers. Not meant to be a documentation for users.
    Creating a directory seems like the easiest way to exclude this from
    doc/.document.

commit 1679ba61f82bcaa7b282681eca42115565f868b2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-23 04:14:58 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-23 04:15:05 +0900

    Update MJIT documentation [ci skip]

commit 4f73de67edc18207148fa311eff8f463ac873981
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-23 03:16:55 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-23 03:16:55 +0900

    Fix typo in array.c

    We should be using the size of RArray and not RString for arrays.

commit 98675ac09cf7bc204b708faea1874b0b0610f309
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-23 03:15:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-23 03:15:04 +0900

    [DOC] IO#read doesn't always read in binary mode

    When `maxlen` is `nil`, it uses the data mode of the stream.
    For example in the following:

    ```ruby
    File.binwrite("a.txt", "\r\n\r")
    p File.open("a.txt", "rt").read    # "\n\n"
    p File.open("a.txt", "rt").read(3) # "\r\n\r"
    ```

    Note, this newline translation is _not_ specific to Windows.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6982

    Merged-By: XrXr

commit bba2bfc97512014134ea1c172e7a077bddebdbad
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-22 02:34:08 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2022-12-23 03:10:22 +0900

    [DOC] encodings.rdoc: universal_newline reacts to \r

    It wasn't clear that the mode also translates "\r" to "\n".

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6981

commit 95a1d1fde8fb13d6b7bd6d63864d3bae8b34b0b0
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 22:41:10 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-23 00:32:35 +0900

    addr2line.c: Support DW_FORM_rnglistx

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6993

commit 53c82a6ce4c90bca5212c2d533014af47c6a5b4e
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 22:39:04 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-23 00:32:35 +0900

    addr2line.c: Implement DW_AT_*_base

    ... and add code to parse the sections of .debug_addr_base and
    .debug_rnglists_base.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6993

commit 515f816b7f3985e0cfa889a574c3b93274d50b6f
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 22:34:34 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-23 00:32:35 +0900

    addr2line.c: Support DW_FORM_strx* forms

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6993

commit 5234f99b76689e7cf711961a737efd4de863460a
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 22:33:06 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-23 00:32:35 +0900

    addr2line.c: Support DW_FORM_addrx* forms

    ... and add VAL_addr value type

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6993

commit 303e11697dab49a3522712cdc0b4d34af1dc6bfc
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 22:29:39 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-23 00:32:35 +0900

    addr2line.c: Keep .debug_str_offsets and .debug_addr sections as well

    clang generates DWARF with the sections

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6993

commit d7388f720c706d94f21ee4e169678a71c73ce37c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-22 05:09:27 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-22 23:23:40 +0900

    Fix buffer overrun with auto-compact for shapes

    The following script crashes:

    ```ruby
    GC.auto_compact = true
    GC.stress = true

    class Foo
      def initialize
        @a = @b = @c = 0
      end

      def add_ivars
        @d = @e = @f = 0
      end
    end

    ary = 1_000.times.map { Foo.new }
    ary.each { |f| f.add_ivars }
    ```

    This is because in rb_grow_iv_list, it first calls
    rb_ensure_iv_list_size to allocate the buffer (and also unsets the
    embed bit) then rb_shape_transition_shape_capa to get the new shape.
    However, auto-compact can trigger in rb_shape_transition_shape_capa
    which would re-embed the object since it doesn't have the new shape yet.
    This causes a crash as the object is now embedded but has a non-embed
    shape which would cause the object to have a buffer overrun.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6986

commit d1d61cabbc332790c0d53fea01f51d52a3489670
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 20:37:40 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-22 20:37:40 +0900

    addr2line.c: Fix another indexing bug

commit ebd6b5d826b1a04b20e477f54723aa5c545cbf69
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 20:26:32 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-22 20:28:03 +0900

    addr2line.c: Fix indexing bug

commit e61e4ae60b1858254051de1e7e90f47185e31491
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-22 15:59:31 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-22 19:27:27 +0900

    Refactor `reg_extract_args` to return regexp if given

commit 78826ad4868c56964d0c47cf37f0100565a5b997
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-22 00:51:46 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-22 18:57:06 +0900

    addr2info.c: Make it work with --enable-yjit

    Background: GCC 12 generates DWARF 5 with .debug_rnglists, while rustc
    generates DWARF 4 with .debug_ranges.

    The previous logic always used .debug_rnglists if there is the section.
    However, we need to refer .debug_ranges for DWARF 4.

    This change keeps DWARF version of the current compilation unit and use
    a proper section depending on the version.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6980

commit c827d724b767a4624b9a3a00c61f181aaf6aef7e
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-21 22:18:48 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-22 18:57:06 +0900

    addr2line.c: Support "Line Number Program Header" in DWARF 5

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6980

commit 2445a4c5b705e6a4bc5113c25d8a6684d0a1df82
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-21 22:13:22 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-22 18:57:06 +0900

    addr2line.c: Keep .debug_line_str section as well

    ... and properly support DW_FORM_line_strp.

    This is a prepartion to support DWARF 5.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6980

commit ed81d0f5f6ef94d9cebb2a7fc848ba001a2b6449
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-22 17:49:43 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-22 17:49:43 +0900

    Update default gems list at fe7190a8c19bb56ca0aefed368402a [ci skip]

commit fe7190a8c19bb56ca0aefed368402af1547dd09a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-22 17:47:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-22 17:48:22 +0900

    [ruby/optparse] Bump version to 0.3.1

    https://github.com/ruby/optparse/commit/2a1e157ae1

commit 298176f23acb6a79ec6bca6767547bf7d7162dfd
  Author:     Kazuki Tsujimoto <kazuki@callcc.net>
  AuthorDate: 2022-12-22 16:20:23 +0900
  Commit:     Kazuki Tsujimoto <kazuki@callcc.net>
  CommitDate: 2022-12-22 16:20:23 +0900

    NEWS.md: Update power_assert version

commit 454c00723a24916daeedde993a8429ab508576d3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 23:17:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-22 15:51:00 +0900

    Share argument parsing in `Regexp#initialize` and `Regexp.linear_time?`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6988

commit bb4cbd0803c3297ad036008adc7a01159ce44e1e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-22 15:46:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-22 15:46:15 +0900

    Put RubyVM::MJIT::Compiler under ruby_vm directory (#6989)

    [Misc #19250]

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 43f4093a313146d1a5c59f7b234872cdd6950c6c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 20:54:24 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-22 15:12:05 +0900

    Adjust style [ci skip]

commit af0ea88b30d8c844a251e344e0da85ea01b2e0aa
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2022-12-22 15:02:36 +0900
  Commit:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  CommitDate: 2022-12-22 15:02:36 +0900

    Fix link [ci skip]

commit 186b5c0086a3b7b02b19f58aeda09016ee1c3d52
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-22 14:49:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-22 14:49:30 +0900

    Revert "Update bundled gems list at 2022-12-22"

    This reverts commit 89a66f20d8701f30f3d9952ae62a02fdefcd166b.

commit 1e193c78d20e567c8eaeedf56b728adb9e0aaf7b
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2022-12-22 14:05:08 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2022-12-22 14:05:08 +0900

    Clarify NEWS entry for Bug #16889

commit 4213f42555a62b565ff99e0ad3e7d3c7f5495180
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2022-12-22 14:02:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-22 14:02:43 +0900

    Make sure TracePoint#binding returns nil for c_call/c_return events

    This makes sure the method returns nil for these events, as
    described in NEWS, even if the TracePoint could create a binding.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6984

    Merged-By: jeremyevans <code@jeremyevans.net>

commit ae455a129e97709d7fd8b11c1e5c3245f4738528
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2021-12-31 03:52:42 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2022-12-22 13:37:58 +0900

    [DOC] Update TracePoint.allow_reentry docs

    Adjust call-seq to mention block, and add examples
    and explanations.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5380

commit b7bb14b96e7e1923d91787fa5a9ca2e4053431b1
  Author:     Kazuki Tsujimoto <kazuki@callcc.net>
  AuthorDate: 2022-12-22 13:05:09 +0900
  Commit:     Kazuki Tsujimoto <kazuki@callcc.net>
  CommitDate: 2022-12-22 13:05:09 +0900

    Update documentation about Time#deconstruct_keys

commit 4e6c44e297a7b504f6390446e2e499a7a97a5363
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-22 12:48:11 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-22 12:48:11 +0900

    [DOC] Fix the paragraph about PRNG update

commit e3847f39a199407059349f19a98cbe790d08f0cd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-22 12:27:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-22 12:27:09 +0900

    Added the missing word with 1e1d7047fcc

commit 1e1d7047fcc741dae66b29c611004d722ad087c9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-22 12:25:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-22 12:25:00 +0900

    Introduce GH releases for default gems and bundled gems

commit 2811d9d224645ea714c3d20ef3d0e6a6661d441f
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-18 19:18:35 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-18 19:18:35 +0900

    NEWS.md: Tweak "Constant lookup when defining a class/module"

commit dd338ae124182b445c688666769cd8b7930ad88c
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-18 18:48:02 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-18 18:48:02 +0900

    NEWS.md: Fix typos

commit 937299ede1a996efa0992b8a8cfb4a5f830b0e5c
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-18 18:47:19 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-18 18:47:19 +0900

    NEWS.md: Fix a typo

commit 89a66f20d8701f30f3d9952ae62a02fdefcd166b
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-22 11:34:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-22 11:34:24 +0900

    Update bundled gems list at 2022-12-22

commit 5b85e4040e130777ab1652a1cbfcbfa170bcc799
  Author:     Kazuki Tsujimoto <kazuki@callcc.net>
  AuthorDate: 2022-12-22 11:12:59 +0900
  Commit:     Kazuki Tsujimoto <kazuki@callcc.net>
  CommitDate: 2022-12-22 11:12:59 +0900

    Update power_assert to 2.0.3

commit 5b76a8ed5694ff451f8140ca21ac5aae6c4145fa
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-22 10:41:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-22 10:41:00 +0900

    Introduce some notable IRB features in NEWS [ci skip]

commit 67ef3cd3ccdaeb1310a550f62a8a23606fb3bced
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-22 09:56:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-22 09:56:41 +0900

    Skip a flaky Ractor test for mswin

commit 2537182063287271fa7240415d2e4c3fddb39ec2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-22 09:45:53 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-22 09:45:54 +0900

    Make it clear that it doesn't update the receiver [ci skip]

commit 4e6b4cce8007a3a174cc2a715ffd21a56edfddd4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-22 09:44:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-22 09:44:47 +0900

    Add Data#with to examples in the NEWS [ci skip]

commit 99cee85775bc5656b942bf4e1b0568a8f40addcd
  Author:     Ufuk Kayserilioglu <ufuk@paralaus.com>
  AuthorDate: 2022-12-22 09:27:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-22 09:27:38 +0900

    Add copy with changes functionality for Data objects (#6766)

    Implements [Feature #19000]

    This commit adds copy with changes functionality for `Data` objects
    using a new method `Data#with`.

    Since Data objects are immutable, the only way to change them is by
    creating a copy. This PR adds a `with` method for `Data` class instances
    that optionally takes keyword arguments.

    If the `with` method is called with no arguments, the behaviour is the
    same as the `Kernel#dup` method, i.e. a new shallow copy is created
    with no field values changed.

    However, if keyword arguments are supplied to the `with` method, then
    the copy is created with the specified field values changed. For
    example:
    ```ruby
        Point = Data.define(:x, :y)
        point = Point.new(x: 1, y: 2)
        point.with(x: 3) # => #<data Point x: 3, y: 2>
    ```

    Passing positional arguments to `with` or passing keyword arguments to
    it that do not correspond to any of the members of the Data class will
    raise an `ArgumentError`.

    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 398aaed2f0e56a81c5c15cc1126b6bbba79ffec0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-22 00:33:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-22 00:34:21 +0900

    Fix the case trailer without newline

    cf0b413ef8b794ef6e7436f22fd5a998050dada9

commit 98fbebf110f0802fd6c72e48eb9d9a6c40878e40
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 23:59:34 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-22 00:01:18 +0900

    [DOC] Fix typo

commit 172dc98c94d1b0356c14e60dfcc4ba1ed2c7ed16
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2022-12-21 06:10:51 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 23:17:19 +0900

    [ruby/net-http] Adding links to references

    https://github.com/ruby/net-http/commit/71bae5c0fe

commit 276b84f8ed1639d22df072c622e0a5d501bf8c5f
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2022-12-21 01:52:26 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 23:17:19 +0900

    [ruby/net-http] Adding links to references

    https://github.com/ruby/net-http/commit/e4df80f299

commit 86f0128efe687a9db2756c9902b4a28f26981b1b
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2022-12-20 02:38:02 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 23:17:18 +0900

    [ruby/net-http] Adding links to references

    https://github.com/ruby/net-http/commit/df5a554fa8

commit 6af6857ecfd5d67e5e9125c7ace0900475481275
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2022-12-21 22:11:51 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-21 22:11:51 +0900

    Set up RBS_SKIP_TESTS (#6862)

    * Set up RBS_SKIP_TESTS

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit befc99c00813568973a6330b2101e27184aab509
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 12:52:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-21 20:48:51 +0900

    [DOC] tool/update-NEWS-refs.rb: Align footnotes

commit c7c006cc68573cea356253cb1cc2c428d83fdf6c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 02:06:03 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-21 20:48:51 +0900

    [DOC] tool/update-NEWS-refs.rb: Remove extra brackets

    Surrounding with brackets is just a convention for the bugs tracker
    links.

commit cc4c28ec2efa71b1c8afb4ce11409ad7b5ca1c95
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2022-12-21 19:13:15 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2022-12-21 19:13:15 +0900

    Make Enumerartor.product return nil when called with a block

commit 308ccbaeb2c1c0e78d59c0411ddbeede8d2324f0
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2022-12-21 18:19:19 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2022-12-21 18:19:19 +0900

    Make product consistently yield an array of N elements instead of N arguments

    Inconsistency pointed out by @mame:

    ```
    >> Enumerator.product([1], [2], [3]).to_a
    => [[1, 2, 3]]
    >> Enumerator.product([1], [2]).to_a
    => [[1, 2]]
    >> Enumerator.product([1]).to_a
    => [1]
    >> Enumerator.product().to_a
    => [nil]
    ```

    Got fixed as follows:

    ```
    >> Enumerator.product([1], [2], [3]).to_a
    => [[1, 2, 3]]
    >> Enumerator.product([1], [2]).to_a
    => [[1, 2]]
    >> Enumerator.product([1]).to_a
    => [[1]]
    >> Enumerator.product().to_a
    => [[]]
    ```

    This was due to the nature of the N-argument funcall in Ruby.

commit 684fa46ee68dd7f1f07d4f7f65861d6875736122
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-21 18:57:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-21 18:57:37 +0900

    Removed empty section

commit e894ff5ec18ff42d90b7977317d1bcaecd51f186
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-21 14:19:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-21 18:57:36 +0900

    Update bundled_gems

commit 1a24442193fe437e761e941d1ae0923d45fbb92f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 15:18:34 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-21 15:18:34 +0900

    test/socket/test_addrinfo.rb: Suppress Errno::EACCES on Windows

commit 9f42ee3e529759dc18a92ed4d3bbd0612787d8fd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 14:32:05 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-21 14:34:40 +0900

    [DOC] Fix formatting

commit 1e989c49a823c7257040fdd1d712a06a5acd6a60
  Author:     Mau Magnaguagno <maumagnaguagno@gmail.com>
  AuthorDate: 2022-12-21 14:28:48 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-21 14:28:48 +0900

    MJIT: Refactor Compiler#cast_offset (#6967)

    Subtract max value from offset when sign bit is set, without string operations.

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 502ca37dde288d20fed6e6ea34f4ab3299de7777
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 14:07:54 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-21 14:09:12 +0900

    [ruby/optparse] The encoding argument of `Regexp.new` has been ignored since 1.9

    https://github.com/ruby/optparse/commit/766f567405

commit afd46429fcdb83aa9fa7c193ede40bff3f3ff151
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2022-01-19 15:14:02 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2022-12-21 11:19:23 +0900

    tool/m4/ruby_wasm_tools.m4: force passing WASI_SDK_PATH when building for wasi

    Make the WASI_SDK_PATH variable mandatory when building for wasi host.
    This requirement prevents developers from being stuck due to unfriendly
    configuration's error message.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5464

commit 2b96119fc00a49813c169d811e43a49ba9833f5f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-21 08:34:23 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-21 09:48:42 +0900

    [DOC] fix unintentional verbatim

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6975

commit 47988e63d65098ce1e6484f03ae5e2ca42bd7963
  Author:     Sorah Fukumori <her@sorah.jp>
  AuthorDate: 2022-01-08 14:03:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-21 09:40:09 +0900

    test_readline#test_without_tty: Use EnvUtil.rubybin

    `ruby` is not always available in certain build environments and
    configure options. Choose appropriate command line using EnvUtil.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5417

commit 2c3475d96ee63871cd14612dd6d113f7c73f6353
  Author:     sampatbadhe <sampat.badhe@kiprosh.com>
  AuthorDate: 2022-12-21 03:48:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-21 08:20:23 +0900

    correct typo [ci skip]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6973

commit 33debffdd3aa0ef9752857530c125f0a889db970
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2022-12-21 07:02:25 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2022-12-21 07:05:56 +0900

    Use "Fiber storage variables" consistently

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6974

commit 4495dea153a097c59d56819bc827bebfbef5be3f
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2022-12-21 06:10:37 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2022-12-21 07:05:56 +0900

    Improve documentation for fiber-scoped variables

    * Especially around Enumerator.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6974

commit 39e70eef724d1c4b50a6ee894c35a3e60773671c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-21 05:18:36 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 05:18:36 +0900

    [DOC] Fix formatting for GC.compact

commit 9f4472cad76ced858e84095bd64089900265f4b4
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-21 05:16:36 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 05:16:36 +0900

    [DOC] Escape all usages of GC

    RDoc was making every usage of the word "GC" link to the page for GC
    (which is the same page).

commit 63fe03aa4e9bba62dec83e5b7927c47b9599eeff
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-21 05:09:14 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 05:09:14 +0900

    [DOC] Fix call-seq for GC methods

    RDoc parses the last arrow in the call-seq as the arrow for the return
    type. It was getting confused over the arrow in the hash.

commit 790b3f7bbde1e1c9594c12e8d8ed8ae9718148f7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-21 05:07:11 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 05:07:11 +0900

    [DOC] Fix formatting for GC#latest_gc_info

commit ae53986834d5220b779ed01bfa7e3f15a3f9b58f
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-21 05:06:06 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 05:06:06 +0900

    [DOC] Fix formatting for GC#latest_compact_info

commit 0efa36ac06a14a3e2e0aca395fee6530c790bdf1
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2022-12-21 02:21:43 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2022-12-21 03:32:23 +0900

    Ensure Fiber storage is only accessed from the Fiber it belongs to

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6972

commit d557f17974384dde4ff2da021a1b38905a39bda2
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2022-12-21 02:10:57 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2022-12-21 03:32:23 +0900

    Use an experimental warning for Fiber#storage=

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6972

commit 45175962a6fd74ab2e9ba92f1280f3987af25494
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2022-12-21 01:59:46 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2022-12-21 03:32:23 +0900

    Never use the storage of another Fiber, that violates the whole design

    * See https://bugs.ruby-lang.org/issues/19078#note-30

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6972

commit 88040063d0ec8aa64e0de2a3afae7286ec53bfdb
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2022-12-20 17:25:05 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2022-12-21 03:17:57 +0900

    Array#pack: document silent truncation

    Ref: [Feature #19245]

    At the very least this behavior should be documented.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6969

commit 3ded50a36c0631aca17f363e68f6beff47713f7e
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-21 02:08:54 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-21 02:08:54 +0900

    Update default gems list at b2bf5d237ba5f2d1ebaf12d164064c [ci skip]

commit b2bf5d237ba5f2d1ebaf12d164064ce8c5b3628f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-21 02:06:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-21 02:07:55 +0900

    [ruby/irb] Version 1.6.2

    https://github.com/ruby/irb/commit/a8ea9963c6

commit cf0b413ef8b794ef6e7436f22fd5a998050dada9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-21 02:05:58 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-21 02:07:54 +0900

    [ruby/irb] Respect DLEXT to force-load debug.so
    (https://github.com/ruby/irb/pull/481)

    https://github.com/ruby/irb/commit/9d82778152

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit 80e56d1438724d37ca09f61e560f95c00599cdf3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-20 23:06:29 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-21 01:32:51 +0900

    Fix thrashing of major GC when size pool is small

    If a size pooll is small, then `min_free_slots < heap_init_slots` is true.
    This means that min_free_slots will be set to heap_init_slots. This
    causes `swept_slots < min_free_slots` to be true in a later if statement.
    The if statement could trigger a major GC which could cause major GC
    thrashing.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6971

commit c72a748b277af14e807aa3c4815a0287a6dce41c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-20 13:33:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-21 00:50:32 +0900

    Win32: add dependency of revision.h

    When out-of-place build, and revision.h does not exist in the source
    directory, `VPATH` fallbacks to the current directory.

commit 25635bbcee64f052e9d66298c25ff3005583bc58
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2022-12-20 16:32:14 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2022-12-21 00:10:27 +0900

    Add links to Wasm port resources to NEWS.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6968

commit 950dc1698910e329fe224720123292e27c9d0981
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-17 19:04:55 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-17 19:04:55 +0900

    Move Coverage-related items to Stdlib section

commit c00f7cfb9b1dc7c79c7858c54205121aeb02bfcb
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-17 18:29:24 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-17 18:29:24 +0900

    Move Socket-related changes to stdlib section

commit 90c8f7ca6bef734d4f347f1ddd3b541ba4ebdea8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-20 13:31:36 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-20 17:53:45 +0900

    Ignore man directories entirely [ci skip]

commit 5716c0f1f84525dc3138125f1c97ef86ae1ff32a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-20 13:32:00 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-20 17:53:41 +0900

    MSVS lacks `touch` [ci skip]

commit 031bc21abba4c2e9ce38bb49c456478073e6672a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-19 22:43:51 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-20 17:40:19 +0900

    expand-config.rb: search revision.h to extract release date

commit 0344283fd30f7e83529a7f4d33bc29886d01e29d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-20 16:04:14 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-20 16:07:10 +0900

    Fix missing parentheses [ci skip]

commit 0ccc498e6e9f1f2884d72381d57c2f97cfa6e59a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-20 00:32:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-20 16:06:32 +0900

    loadpath.c does not depend on revision.h since 947ebd0ac5ba

commit 5c21cc39704f7e50b12f19c423e17ab275f74fbe
  Author:     Mike Dalessio <mike.dalessio@gmail.com>
  AuthorDate: 2022-12-19 06:59:03 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2022-12-20 15:57:22 +0900

    configure.ac: limit miniruby dep to when bundle_loader needs it

    See also e7bffe0

    https://bugs.ruby-lang.org/issues/19239

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6959

commit a5a40259e4a54bb08b22b5f34c09e7106cbee51b
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-20 14:50:57 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-20 14:50:57 +0900

    Update default gems list at 20f9316f9dd5c77f96f1c08adb8da7 [ci skip]

commit 20f9316f9dd5c77f96f1c08adb8da7e91d666f3b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-20 14:39:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 14:50:08 +0900

    [ruby/syntax_suggest] Bump version to 1.0.2

    https://github.com/ruby/syntax_suggest/commit/92ea00650a

commit 2e7e153a2af1456515d43b6381e38534b069b1c2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-19 14:10:58 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-20 14:12:38 +0900

    [Bug #19242] Prohibit circular causes to be loaded

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6960

commit 18ba89093a0b214cd89f1567c037c239f094496d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-20 09:43:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    Merge RubyGems/Bundler master

      Pick from https://github.com/rubygems/rubygems/commit/ba3adad4d80038ffd7bea015da2f11d3e8a2ff82

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit ad1f61fe80dea7a1b1e8d27a4232d7b10b820960
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-20 03:39:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Bump rb-sys

    Bumps [rb-sys](https://github.com/oxidize-rb/rb-sys) from 0.9.48 to 0.9.52.
    - [Release notes](https://github.com/oxidize-rb/rb-sys/releases)
    - [Commits](https://github.com/oxidize-rb/rb-sys/compare/v0.9.48...v0.9.52)

    ---
    updated-dependencies:
    - dependency-name: rb-sys
      dependency-type: direct:production
      update-type: version-update:semver-patch
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit ae30b42621448325947e9bb8190653687ecd6f68
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-20 00:05:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Bump rb-sys in /test/rubygems/test_gem_ext_cargo_builder/custom_name

    Bumps [rb-sys](https://github.com/oxidize-rb/rb-sys) from 0.9.48 to 0.9.52.
    - [Release notes](https://github.com/oxidize-rb/rb-sys/releases)
    - [Commits](https://github.com/oxidize-rb/rb-sys/compare/v0.9.48...v0.9.52)

    ---
    updated-dependencies:
    - dependency-name: rb-sys
      dependency-type: direct:production
      update-type: version-update:semver-patch
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 870bcc96bab644656cd914b5061fcacc39db6557
  Author:     Mark Burns <markburns@users.noreply.github.com>
  AuthorDate: 2022-12-19 02:55:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] fix
    https://github.com/rubygems/rubygems/pull/6147 when --parseable and
    --groups used
    together

    https://github.com/rubygems/rubygems/commit/3b0b95c509

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 8eb66180137e3cba030d43fba21980efa5f58bb3
  Author:     Josef Šimánek <josef.simanek@gmail.com>
  AuthorDate: 2022-12-17 22:34:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Turn `--ext` option into string. Deprecate usage without explicit value.

    - this is preparation for onboarding Rust based extension gem generator

    https://github.com/rubygems/rubygems/commit/d32801bdbc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit eaf0157dd1ad6cfbecedd9ff4158954418c1331c
  Author:     Josef Šimánek <josef.simanek@gmail.com>
  AuthorDate: 2022-12-17 22:35:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Regenerate bundler man pages for December 2022.

    https://github.com/rubygems/rubygems/commit/17037fe32c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit f270aa3eda535f3eb3f77912cf4a7a80f240b89e
  Author:     Josef Šimánek <josef.simanek@gmail.com>
  AuthorDate: 2022-12-17 16:47:52 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Use safe Marshal deserialization for dependency API response. - adds Bundler#safe_load_marshal and Bundler::SAFE_MARSHAL_CLASSES listing safe classes to deserialize

    https://github.com/rubygems/rubygems/commit/e947c608cc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit efd103f3e58fcf3aeb6c4a0d3dd9233448698231
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-17 09:54:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Fix crash when showing some resolution errors

    If the conflict explanation includes empty ranges and version unions,
    Pub Grub was crashing.

    https://github.com/rubygems/rubygems/commit/eb360b77a2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 1db9bcfeaf27b8a8ced1ea5ad13f5c5774530a6b
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-17 09:20:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Fix crash when building resolution errors with OR requirements

    https://github.com/rubygems/rubygems/commit/8f287479bc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 829348956476fc395f267b3f4a20ea67546551b2
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-17 08:53:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Slight tweak to error message building

    Let Pub Grub decide how the constraint should be displayed.

    https://github.com/rubygems/rubygems/commit/4f651b6429

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit beef72965e8d3e23bfc37a6da553d171357ec7f3
  Author:     Michael Siegfried <michaeldsiegfried@gmail.com>
  AuthorDate: 2022-12-17 02:20:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Clarify flag description

    Prerelease versions are already considered in a certain circumstance,
    and the 'if updating' is redundant in the update case anyway.

    https://github.com/rubygems/rubygems/commit/8d68635f8c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 32e72b78b31a80d308f9762913399d179ed96914
  Author:     Michael Siegfried <michaeldsiegfried@gmail.com>
  AuthorDate: 2022-12-16 10:33:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Add tests for bundle lock

    Ensure `bundle lock` handles pre flag just like bundle update does.

    https://github.com/rubygems/rubygems/commit/b9e85e3157

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 42972bdd9259c93c007ecb48987f0b617a5f21e0
  Author:     Michael Siegfried <michaeldsiegfried@gmail.com>
  AuthorDate: 2022-11-17 11:00:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Test the public interface

    With `GemVersionPromoter#sort_versions` being so simple, we no longer
    need to reach into the class's internals to make private methods public
    in order to effectively test. We can just allow both cases to go through
    the main method.

    https://github.com/rubygems/rubygems/commit/6cbe891003

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit c436f52fe81b90e09376c9b75ac4cb4a4b090e32
  Author:     Michael Siegfried <michaeldsiegfried@gmail.com>
  AuthorDate: 2022-11-17 10:52:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Fix tiny typo

    https://github.com/rubygems/rubygems/commit/390e3e1ebd

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 2bc4f1dea5e663acba1d3c662390e8fc20bf6721
  Author:     Michael Siegfried <michael@procore.com>
  AuthorDate: 2022-01-05 07:54:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Support for pre flag in `bundle update`

    Passing this flag allows bumping to the current version, even if that
    version is prerelease. This works in concert with the current flags.

    https://github.com/rubygems/rubygems/commit/a6409e3509

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 1ee31f9d9dc8da4b0eb8ca39b79a6b270c6c2f2d
  Author:     Michael Siegfried <michaeldsiegfried@gmail.com>
  AuthorDate: 2022-11-17 09:19:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Clarify segment equality check

    https://github.com/rubygems/rubygems/commit/6624474c5a

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit e58d18bf23a4dff7f17c76e6a3c762896cc2d807
  Author:     Michael Siegfried <michaeldsiegfried@gmail.com>
  AuthorDate: 2022-11-17 09:18:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Return early outside of loop

    The conditions are not dependent on each spec and can be checked once at
    the beginning of the method.

    https://github.com/rubygems/rubygems/commit/086bc9433f

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit c67f6c4dafbc868c36b3e021331fe0b1fac680f5
  Author:     Michael Siegfried <michaeldsiegfried@gmail.com>
  AuthorDate: 2022-11-17 09:13:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Add question marks to interrogative methods

    https://github.com/rubygems/rubygems/commit/52da85e9ef

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 0a9544ce4ab86963dde0f3ad0b489b6a354cc8b3
  Author:     Eloy Espinaco <eloyesp@gmail.com>
  AuthorDate: 2022-11-30 11:40:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Cleanup intermediate artifacts after installing built extensions

    https://github.com/rubygems/rubygems/commit/98b6a959bd

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 9d10b8393e6692d076d79d3b80c6eefb40a65b44
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-16 21:37:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Use better name for variable

    The installed file not always have the `.so` extension.

    https://github.com/rubygems/rubygems/commit/6f6681bcb9

    Co-authored-by: Eloy Espinaco <eloyesp@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 012ef7d1d035f2c5cdb06bea777c22d72acc78c9
  Author:     Eloy Espinaco <eloyesp@gmail.com>
  AuthorDate: 2022-11-29 02:09:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Fix tests checking intermediate files

    Some tests check that the shared objects are actually installed, but
    checking an intermediate build file instead of the installed one.

    https://github.com/rubygems/rubygems/commit/ad526073b0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 3fd33590f624ff74d91c1d505f85653902764384
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-15 20:14:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Fix crash when lockfile is missing dependencies

    We have a check for a corrupt lockfile right before installing. However,
    the check accounted for locked specs not satisfying locked dependencies,
    but not for locked specs missing for some locked dependencies.

    Instead of fixing this check, I decided to remove it in favor of
    automatically detecting the situation and re-resolve to automatically
    fix the lockfile rather than printing a warning but leave the problem
    there.

    https://github.com/rubygems/rubygems/commit/4a7a584252

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 16b36a5b0c71afdcd125c530ee6fb809d4306822
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-15 20:22:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Remove unused code

    https://github.com/rubygems/rubygems/commit/b88c43a28c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit d1533f20f1c3f9b6f2324c62ab1460996cda174a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-14 02:08:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Detect circular dependency errors

    https://github.com/rubygems/rubygems/commit/a8348d271d

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit 96aa1a1a9888720d73321013a5cb4de20381a974
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-14 00:30:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Remove dead logic

    https://github.com/rubygems/rubygems/commit/950615405e

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit d1c210355b0c27fa5846cd0fd0c55358a7d5a0e0
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-14 00:31:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-20 13:15:02 +0900

    [rubygems/rubygems] Extract a variable for consistency

    https://github.com/rubygems/rubygems/commit/3f4b1c7a01

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6966

commit fe3dedb21a945063724502e96c21ed3682c61c18
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-17 08:51:20 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-17 08:51:20 +0900

    Prevent a "method redefined" warning

commit 2013dd465811b6d01129f25af4fbe84002a2273f
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-17 08:40:36 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-17 08:40:36 +0900

    Prevent warning "assigned but unused variable - initial_shape"

commit 8f081d4d0ffb7edd33f0e0833e9e4d73601740bb
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-20 07:55:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-20 07:55:49 +0900

    Syntax-highlight scripts in yjit.md [ci skip]

    Specifically, I wanted to grey out comments in shell scripts. But I just
    specified a language for blocks without comments as well to avoid
    forgetting that in the future.

commit e7915d6d7042c7945195289d882aa91e35dc9404
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-20 01:44:00 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-20 07:09:08 +0900

    Fix misfire of compaction read barrier

    gc_compact_move incorrectly returns false when destination heap is full
    after sweeping. It returns false even if destination heap is different
    than source heap (returning false means that the source heap has
    finished compacting). This causes the source page to get locked, which
    causes a read barrier fire when we try to compact the source heap again.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6963

commit 650a20a3e1205f47224a987676cdbad7d826d597
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-20 06:59:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-20 06:59:36 +0900

    Re-enable test_ractor for YJIT

    This would be still flaky, but we want to make sure there's no
    YJIT-specific issue when Ruby 3.2 is released. We might skip it again
    after the release.

commit 8275cad1e1646a2b301962313dc3e8ff1deb87b3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-20 01:21:16 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-20 03:13:26 +0900

    Fix buffer overrun when re-embedding objects

    We eagerly set the new shape of an object when moving an object during
    compaction. This new shape may have a different capacity than the
    current original shape capacity. This means that we cannot copy from the
    original buffer using size of the new capacity. Instead, we should use
    the ivar count (which is less than or equal to both the new and original
    capacities).

    Co-Authored-By: Matt Valentine-House <matt@eightbitraptor.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6962

commit b2f53dccbedd9f399bc4668eb02f26b2eafa6f5c
  Author:     Mau Magnaguagno <maumagnaguagno@gmail.com>
  AuthorDate: 2022-12-20 00:44:23 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-20 00:44:23 +0900

    YJIT: skip map in print_sorted_exit_counts (#6954)

    Array#sum accepts a block.

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 1482f0649e303c8bf11281268d3e1e6e2370c093
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-20 00:26:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-20 00:26:21 +0900

    YJIT: Improve the description about --enable-yjit (#6947)

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit bcdc9cf1590caeda83c4e8f90f27a4a80b152e08
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-20 00:19:56 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-20 00:19:56 +0900

    YJIT: Make --yjit-stats always visible on --help (#6946)

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 1148636e3dfb3aa25485b6e5cf40c043df848c07
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-19 17:29:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-19 17:49:59 +0900

    [ruby/irb] PTY module is platform dependent

    https://github.com/ruby/irb/commit/dbb3dc72ff

commit 9761422f47f6c06b8aa332b7c941a5874319508a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 15:55:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 15:55:13 +0900

    Added news entries for Bundler

commit 919b5bfce3745766e9decb5357f5ecc9f8bb513f
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-19 15:00:53 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-19 15:00:53 +0900

    Update default gems list at 1142bc875bc00d492046ecbf781f07 [ci skip]

commit 1142bc875bc00d492046ecbf781f076a78e4b8c5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 14:59:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 14:59:59 +0900

    [ruby/did_you_mean] Bump version to 1.6.3

    https://github.com/ruby/did_you_mean/commit/f7703add76

commit 2605ff79aa84a635d135c5892339483e337bbd03
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-19 14:47:37 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-19 14:48:18 +0900

    tool/update-NEWS-refs.rb: Accept non-redmine url links

commit 65ce6795feacd19d44b230f5d729ecb891fcb349
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2022-12-19 14:39:02 +0900
  Commit:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  CommitDate: 2022-12-19 14:39:02 +0900

    Sort by URL [ci skip]

commit 9a48459393d27229759ea484ad5244b71fc4e614
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 14:20:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 14:22:18 +0900

    Added notable changes for the default gems

commit c41a7012ca79ad9bcf6f4c7b422caac82c99fb98
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-19 13:27:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-19 14:09:30 +0900

    Use pthread API if the target platform doesn't support TLS attribute

commit 4de514da383ef70d784e2ddded42e74375880996
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-19 14:04:10 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-19 14:04:10 +0900

    Revert "Mentioned https://github.com/ruby/ruby/pull/6086 to NEWS"

    This reverts commit 6229c02d6b895eda8c73efa8a41c73692d133a65.

    Nothing has been changed in RubyVM.stat on normal Ruby build. It seems
    confusing to say that something has been changed there. The flag is
    supposed to be enabled only by CRuby developers, and it's not efficient
    enough for public consumption.

commit d64e10228da1cabf07c3d5f6289e219a12d4cd86
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-19 13:14:46 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-19 13:14:46 +0900

    Fix guess_diff type

    `unsigned_time_t` has the same size as `time_t`, but it doesn't mean
    these types are same except for signedness.  For instance, while
    `long` and `long long` has the same size and `time_t` is defined as
    the latter on 64bit OpenBSD, `unsigned_time_t` has been defined as
    `long`.

commit df4820e749fbada28b622ccd36c3a1d542231705
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 12:10:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 12:10:02 +0900

    Added some changes that are only exists on GitHub to NEWS

commit 40ec3762d233de12a04bd6321fc32ef1affd7852
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 11:45:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 11:45:23 +0900

    Mentioned https://github.com/ruby/date/pull/80

commit 289d99cc62985e9a8834e80a1da424c1bdbb4502
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 11:43:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 11:43:56 +0900

    Merge Time class sections on NEWS

commit 6229c02d6b895eda8c73efa8a41c73692d133a65
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 11:38:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 11:38:25 +0900

    Mentioned https://github.com/ruby/ruby/pull/6086 to NEWS

commit 63a9b72c171219db9310ee613a69d5bcc5926220
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 11:34:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 11:34:17 +0900

    Removed empty section

commit 34d43ed9f5f8c4fb56913d176669b587a696dc94
  Author:     卜部昌平 <shyouhei@ruby-lang.org>
  AuthorDate: 2022-12-19 11:20:55 +0900
  Commit:     卜部昌平 <shyouhei@ruby-lang.org>
  CommitDate: 2022-12-19 11:20:55 +0900

    typo in doc [ci skip]

commit 47a6e7b518bf5bebd293519ee89b77c06830f21d
  Author:     卜部昌平 <shyouhei@ruby-lang.org>
  AuthorDate: 2022-12-19 10:28:51 +0900
  Commit:     卜部昌平 <shyouhei@ruby-lang.org>
  CommitDate: 2022-12-19 11:05:55 +0900

    Note about Regexp.linear_time? [ci skip]

commit e123695fbccb36e804f5d386a23fd3968b60b825
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-19 10:51:11 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-19 10:51:11 +0900

    Update default gems list at 08d21b4bd2000596160d62f28b840b [ci skip]

commit 08d21b4bd2000596160d62f28b840b53e26d738d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 10:39:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 10:50:21 +0900

    [ruby/net-http] Bump version to 0.3.2

    https://github.com/ruby/net-http/commit/b8bdb7248e

commit 1998d979085bdcd2db25db76709dc49c3cd7fffb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-19 10:48:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-19 10:50:21 +0900

    [ruby/date] Bump version to 3.3.3

    https://github.com/ruby/date/commit/ea3644a7c4

commit 6073782627b8a4976cab232daab2350e36c21cdd
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2022-12-19 09:45:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-19 09:45:50 +0900

    Disable SEH workaround on __MINGW64__ only. (#6957)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit d4315284e9382caf264e66ecf890f5a45d85c5e3
  Author:     Alyssa Ross <hi@alyssa.is>
  AuthorDate: 2019-01-21 21:10:53 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-19 04:17:42 +0900

    [rubygems/rubygems] Add bundle lock --update --bundler

    bundle lock --update can do everything that bundle update can do, but
    it doesn't actually install gems. This is especially useful for
    generating a lockfile on a machine that doesn't have the libraries
    available to be able to build native extensions.

    But, there was no parallel for bundle update --bundler. So let's add
    one.

    https://github.com/rubygems/rubygems/commit/7fc00bd2a5

commit ede7c035d58a3384b684051647aa56f258ecc286
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2022-12-18 08:09:50 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-19 00:37:45 +0900

    [ruby/net-http] Adding links to references

    https://github.com/ruby/net-http/commit/6dfe6f411a

commit 7e93f7ceb75615efe5424222be6a5ec780fa718e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-18 14:24:14 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-18 14:24:14 +0900

    Suppress cross tool warning for pkg-config [ci skip]

    It is used from mkmf.rb on target environments.

commit e7bffe0c4b8bebabc89e7440efffa43ee3e1123e
  Author:     Mike Dalessio <mike.dalessio@gmail.com>
  AuthorDate: 2022-12-18 03:43:24 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2022-12-18 12:56:53 +0900

    configure.ac: add miniruby to PREP when cross-compiling to darwin

    miniruby is used to resolve symbols in ext bundles

    https://bugs.ruby-lang.org/issues/19239

    Co-authored-by: Yuta Saito <kateinoigakukun@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6944

commit c316a5f2f12fe5921baac50623ca789be490f657
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-18 12:03:46 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-18 12:03:54 +0900

    [ruby/date] Adjust format [ci skip]

    https://github.com/ruby/date/commit/71c35b4054

commit b8cc0992c681de30d48e9c9bdb59721604c194b5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-18 11:38:07 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-18 11:58:51 +0900

    [ruby/date] Extract `head_match_p` and abbreviated name length constants

    https://github.com/ruby/date/commit/3f666fa882

commit df49bf8150ee0a6ea2a06b0d2288863b2032c932
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-30 01:11:32 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-18 11:58:50 +0900

    [ruby/date] Consider the length of string to parse

    https://github.com/ruby/date/commit/3bfed83ce7

commit 49dc424ff304149a847880f7c6c19179668f94de
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-30 01:10:16 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-18 11:58:49 +0900

    [ruby/date] Remove `extz_pats` table

    https://github.com/ruby/date/commit/945e26e243

commit 70c905963e71667c1c8b131f290f1d5436d104e0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-30 01:09:38 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-18 11:58:48 +0900

    [ruby/date] Remove `merid_names` table

    https://github.com/ruby/date/commit/7fe2bd5f94

commit 6efeaabef05253cfce64f2d7c94be57cd7d4acd5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-30 00:43:54 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-18 11:58:47 +0900

    [ruby/date] Match abbreviated day and month names with head of full names

    https://github.com/ruby/date/commit/a45f8f03c9

commit ea3d3c455294b2ad94c93cbe0e61921d71f1d9d3
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2022-12-17 10:00:13 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2022-12-18 07:51:49 +0900

    Use FL_TEST_RAW in rb_hash_default_value

    We should always have a T_HASH here, so we can use FL_TEST_RAW to avoid
    checking whether we may have an immediate value.

    I expect this to be a very small performance improvement (perf stat
    ./miniruby benchmark/hash_aref_miss.rb shows a ~1% improvement). It also
    removes 9 instructions from rb_hash_default_value on x86_64.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6945

commit fbaa5db44a3b0622e2755fd00e0519a603aa9bcb
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2022-12-16 03:46:24 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2022-12-18 07:51:49 +0900

    Use a BOP for Hash#default

    On a hash miss we need to call default if it is redefined in order to
    return the default value to be used. Previously we checked this with
    rb_method_basic_definition_p, which avoids the method call but requires
    a method lookup.

    This commit replaces the previous check with BASIC_OP_UNREDEFINED_P and
    a new BOP_DEFAULT. We still need to fall back to
    rb_method_basic_definition_p when called on a subclasss of hash.

        |                |compare-ruby|built-ruby|
        |:---------------|-----------:|---------:|
        |hash_aref_miss  |       2.692|     3.531|
        |                |           -|     1.31x|

    Co-authored-by: Daniel Colson <danieljamescolson@gmail.com>
    Co-authored-by: "Ian C. Anderson" <ian@iancanderson.com>
    Co-authored-by: Jack McCracken <me@jackmc.xyz>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6945

commit 632beec01f6a293aa03da06f5f0e6f9a7c22a8c5
  Author:     Mau Magnaguagno <maumagnaguagno@gmail.com>
  AuthorDate: 2022-12-18 06:06:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-18 06:06:50 +0900

    MJIT: Refactor BitField dereference byte and bitmask (#6955)

    Prefer Array#unpack1 and Enumerable#sum.
    I think the bitmask formula ``2 ** @width - 1`` would be clearer, but not faster for such small integers.

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 6e3bc6710324aeb75299c9edce305b6f7c22321c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-17 23:18:54 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-17 23:18:54 +0900

    Hard crash when allocating in GC when RUBY_DEBUG

    Not all builds have RGENGC_CHECK_MODE set, so it should also crash when
    RUBY_DEBUG is set.

commit 965f4259db5ad59045f778d4129f65e381aab004
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-17 23:13:46 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-17 23:16:26 +0900

    Move check for GC to xmalloc and xcalloc

    Moves the check earlier to before we actually perform the allocation.

commit 9da5a7e79dcaed9bf233f6a9a5df54c727f60c77
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2022-12-17 16:43:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-17 16:43:21 +0900

    Add tests for `Queue#pop` with fiber scheduler. (#6953)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 297df9240772a14141988aef63400e3988584ced
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2022-12-16 06:38:53 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-17 03:27:45 +0900

    Clean up Ruby Shape API

    Make printing shapes better, use a struct instead of specific methods
    for each field on a shape.

    Co-Authored-By: Aaron Patterson <tenderlove@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6942

commit 2ccf6e539458ef5c9f7a2d68163089d1d38e47f7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-16 23:06:26 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-17 00:01:53 +0900

    Don't allow allocating memory during GC

    Allocating memory (xmalloc and xrealloc) during GC could cause GC to
    trigger, which would crash with `[BUG] during_gc != 0`. This is an
    intermittent bug which could be hard to debug.

    This commit changes it so that any memory allocation during GC will
    emit a warning. When debug flags are enabled it will also cause a crash.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6921

commit 3d2eb7c9a6d473411bf2f08dcf9bbdbb59ea93cb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-11-18 13:47:10 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-16 22:52:59 +0900

    [Feature #18033] [DOC] Add NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/4825

commit 3e49d62bc1696a7943e4407328714e32b539b007
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-11-18 14:18:27 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-16 22:52:59 +0900

    [Feature #18033] Parse more strictly conformant with ISO-8601

    * 4-digits or more is required as year
    * Minutes and seconds parts are not ommittable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/4825

commit 635fc5f7fc88a2344118e7a156ff1b2644d0de0c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-11-18 14:17:10 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-16 22:52:59 +0900

    [Feature #18033] Make more conformant with C standard

  Notes:
    Merged: https://github.com/ruby/ruby/pull/4825

commit 9515179d74f2d9934c1b2c69879d72254d940f85
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-10-23 23:32:25 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-16 22:52:59 +0900

    [Feature #18033] Add `precision:` option

    Which limits the precision of subsecond. Defaulted to 9, that
    means nanosecond.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/4825

commit 67c589afa05b1a894ed07969bec16647eff4e593
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-09-19 14:06:59 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-16 22:52:59 +0900

    [Feature #18033] More strict checks

  Notes:
    Merged: https://github.com/ruby/ruby/pull/4825

commit 0a2f300a8a21e013e5debb639adba77fb18b5f40
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-16 11:55:54 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-16 22:52:59 +0900

    [Feature #18033] Name a magic number

  Notes:
    Merged: https://github.com/ruby/ruby/pull/4825

commit 8c272f44816f098c1e057c72a47451efc8cd1739
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-09-05 00:24:23 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-16 22:52:59 +0900

    [Feature #18033] Make Time.new parse time strings

    `Time.new` now parses strings such as the result of `Time#inspect`
    and restricted ISO-8601 formats.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/4825

commit ee7a338d2b21a84d194015c3680bd2a95c0dd23f
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-16 04:04:41 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2022-12-16 20:15:50 +0900

    Unconditionally warn "unknown pack/unpack directive"

    [Bug #19150]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6948

commit b9ea83fc1c95dba0f5548e6bd1b2fa40c6e65e2d
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-16 02:20:59 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-16 02:21:50 +0900

    Update NEWS.md

    Regexp optimization and Wasm support are added.

commit f2690be746ae0c79d7f1d9eb431eb7cf25761d95
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-16 15:47:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-16 15:48:00 +0900

    Removed temporary workaround for syntax_suggest tags

commit 850661dd6dd873329102952d0097fe3416d1b81b
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-16 15:36:43 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 15:36:43 +0900

    Update default gems list at 11f3bef260258c4c8a05ea35ab3bf8 [ci skip]

commit 11f3bef260258c4c8a05ea35ab3bf8a4998e1ff0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-16 15:35:49 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 15:36:03 +0900

    [ruby/date] Bump version to 3.3.2

    https://github.com/ruby/date/commit/7afd9d4615

commit 5983df93d479d0b6cd1eb5024efa27fb62226787
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-16 15:35:45 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 15:35:45 +0900

    Update default gems list at 2cd22f9abd2e759a94452b54408a68 [ci skip]

commit 2cd22f9abd2e759a94452b54408a682fce78bdb9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-16 15:34:16 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 15:34:47 +0900

    [ruby/logger] Bump version to 1.5.3

    https://github.com/ruby/logger/commit/4e8d9e27fd

commit 5e5f3f6bd1ca980685849ca9fc79ef685e1cd252
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-16 13:59:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-16 13:59:04 +0900

    Followed up ad18d1297ed82aa9c38375532b0b709131cf1ae7 with tool/update-deps --fix

commit ad18d1297ed82aa9c38375532b0b709131cf1ae7
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2022-12-16 13:32:13 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2022-12-16 13:32:13 +0900

    Reject keyword arguments given to Enumerator::Product.new

    The use of keyword arguments should be reserved for future extension.

commit 29cb767a1c1ea5d3726ce969cb02f7305f4b1476
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-16 12:53:18 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 12:53:18 +0900

    Update default gems list at d95ee114621c3cd34b4a34233888bb [ci skip]

commit d95ee114621c3cd34b4a34233888bbe0780f1c28
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-16 12:44:31 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 12:45:11 +0900

    [ruby/io-console] Bump version to 0.6.0

    https://github.com/ruby/io-console/commit/441528e3eb

commit bb7844569523132c851e6cb8f2a2406378cc2b51
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-16 11:37:02 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 11:37:02 +0900

    Update default gems list at 7e26ff7dc008ce14e34b43b8ee04a7 [ci skip]

commit 7e26ff7dc008ce14e34b43b8ee04a7aa09cd5886
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-16 11:34:34 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 11:36:21 +0900

    [ruby/io-wait] Bump version to 0.3.0

    https://github.com/ruby/io-wait/commit/940ba319d3

commit dbf77d420d49e541c59f4c14b8e56d3e7af689aa
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2022-12-16 11:12:37 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2022-12-16 11:12:37 +0900

    surpress warning

    now `enc_table->list` is not a pointer.

commit d6624db92608f65b5ba91de8a927916f7b096c5b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-15 13:55:37 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 10:10:46 +0900

    [ruby/irb] Prefer to use File.open instead of Kernel.open

    https://github.com/ruby/irb/commit/ed9e435a6b

commit ae19ac5b5ba1e613a788addeb6d4d67fa65f6518
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2022-12-15 17:53:55 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2022-12-16 10:04:37 +0900

    fixed encoding table

    This reduces global lock acquiring for reading.
    https://bugs.ruby-lang.org/issues/18949

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6935

commit 15b60bb1a48b98e2ba267c88551803df5f88355e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-16 09:13:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-16 09:13:35 +0900

    Mentioned https://bugs.ruby-lang.org/issues/17767 on NEWS.md

commit 5ca46399f111a8beda05bf99fc2c56e5c3076498
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-16 09:02:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-16 09:02:27 +0900

    Add NEWS entries about CGI and ERB [ci skip]

commit 14158f1f8c50069f076f99e08405c5006ca65df9
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-16 08:10:28 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-16 08:10:28 +0900

    YJIT: Fix `obj.send(:call)`

    All the method call types need to handle argument shifting in case they're
    called by `.send`, and we weren't handling that in `OPTIMIZED_METHOD_TYPE_CALL`.

    Lack of shifting caused the stack size assertion in gen_leave() to fail.

    Discovered by Rails CI: https://buildkite.com/rails/rails/builds/91705#018516c4-f8f8-469e-bc2d-ddeb25ca8317/1920-2067
    Diagnosed with help from `@eileencodes` and `@k0kubun`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6943

    Merged-By: XrXr

commit e9ba3042e13313944fd2695731d0d7498532b80f
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2022-12-16 03:42:24 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2022-12-16 06:41:47 +0900

    Indicate if a shape is too_complex in ObjectSpace#dump

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6939

commit c505448cdbd4cd1a52ed7108095f6738d29b3419
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-16 03:54:07 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-16 06:33:46 +0900

    Move definition of SIZE_POOL_COUNT back to gc.h

    SIZE_POOL_COUNT is a GC macro, it should belong in gc.h and not shape.h.
    SIZE_POOL_COUNT doesn't depend on shape.h so we can have shape.h depend
    on gc.h.

    Co-Authored-By: Matt Valentine-House <matt@eightbitraptor.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6940

commit d5eafaed812bc683d5069154c5c9391ba98ea151
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2022-12-16 00:11:06 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-16 06:33:19 +0900

    [ruby/net-http] Enhanced RDoc for Net::HTTP

    https://github.com/ruby/net-http/commit/da626e4e42

commit 4872e8ef14800811d98d3eb6d627386842f87f3f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-16 06:06:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-16 06:06:29 +0900

    Improve Struct NEWS [ci skip]

    I meant to commit diff, but it was left uncommitted locally.

commit 5e81cf8fd009d1aa74b49dce8ba174cd65776d15
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-16 04:20:32 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-16 05:27:38 +0900

    Refactor to only attempt to move movable objects

    Moves check for gc_is_moveable_obj from try_move to gc_compact_plane.

    Co-Authored-By: Matt Valentine-House <matt@eightbitraptor.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6938

commit bfc66e07b7e0134dfa2041c311dc56941fe1caf0
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2022-12-14 00:11:57 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-16 05:27:38 +0900

    Fix Object Movement allocation in GC

    When moving Objects between size pools we have to assign a new shape.

    This happened during updating references - we tried to create a new shape
    tree that mirrored the existing tree, but based on the root shape of the
    new size pool.

    This causes allocations to happen if the new tree doesn't already exist,
    potentially triggering a GC, during GC.

    This commit changes object movement to look for a pre-existing new tree
    during object movement, and if that tree does not exist, we don't move
    the object to the new pool.

    This allows us to remove the shape allocation from update references.

    Co-Authored-By: Peter Zhu <peter@peterzhu.ca>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6938

commit 5fa608ed79645464bf80fa318d89745159301471
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-16 05:10:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-16 05:10:14 +0900

    YJIT: Fix code GC freeing stubs with a trampoline (#6937)

    Stubs we generate for invalidation don't necessarily co-locate with the
    code that jump to the stub. Since we rely on co-location to keep stubs
    alive as they are in the outlined code block, it used to be possible for
    code GC inside branch_stub_hit() to free the stub that's its direct
    caller, leading us to return to freed code after.

    Stubs used to look like:

    ```
    mov arg0, branch_ptr
    mov arg1, target_idx
    mov arg2, ec
    call branch_stub_hit
    jmp return_reg
    ```

    Since the call and the jump after the call is the same for all stubs, we
    can extract them and use a static trampoline for them. That makes
    branch_stub_hit() always return to static code. Stubs now look like:

    ```
    mov arg0, branch_ptr
    mov arg1, target_idx
    jmp trampoline
    ```

    Where the trampoline is:

    ```
    mov arg2, ec
    call branch_stub_hit
    jmp return_reg
    ```

    Code GC can now free stubs without problems since we'll always return
    to the trampoline, which we generate once on boot and lives forever.

    This might save a small bit of memory due to factoring out the static
    part of stubs, but it's probably minor.

    [Bug #19234]

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 53db8fb450a06d6eea8c7452a006b17bd9354c67
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-16 04:53:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-16 04:54:12 +0900

    Add Struct examples to NEWS [ci skip]

commit 2ae0e27a6964d621785f255765461e19d2038880
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-16 04:49:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-16 04:49:59 +0900

    Add Data.define examples to NEWS [ci skip]

commit c0b14e128ff2114e9fc226a5bce117f7fb1d4a19
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2022-12-16 04:45:38 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2022-12-16 04:46:55 +0900

    Update NEWS.md to include shapes and gc bitmap marking

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6941

commit 8b0e44214c91ceddf6e7189348bad07e8983fca7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-16 03:45:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-16 03:45:41 +0900

    Fix missing variables

    It was a bad copy-paste.

commit e25beac145dd3b3943dcf270a2f0d7c7f8c12e60
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-16 03:40:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-16 03:43:21 +0900

    Enable Slack notifications on more Actions

    auto_request_review, codeql-analysis, scorecards don't have it either,
    but those are intentional.

commit ef008d8946d004dc273a033ab399b0df6c71e4f3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-16 03:07:50 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-16 03:08:11 +0900

    Partially revert "Update bundled_gems"

    This reverts the net-imap upgrade of commit e3ed6c07832edf2a95bae3bdd908cc3f5b65eebe.
    net-imap tests of test-bundled-gems seem to be broken
    https://github.com/ruby/ruby/actions/runs/3704473689/jobs/6277145052.

commit c1ab6ddc9a6fa228caa5d26b118b54855051279c
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2022-12-09 07:16:52 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2022-12-16 03:06:04 +0900

    Transition complex objects to "too complex" shape

    When an object becomes "too complex" (in other words it has too many
    variations in the shape tree), we transition it to use a "too complex"
    shape and use a hash for storing instance variables.

    Without this patch, there were rare cases where shape tree growth could
    "explode" and cause performance degradation on what would otherwise have
    been cached fast paths.

    This patch puts a limit on shape tree growth, and gracefully degrades in
    the rare case where there could be a factorial growth in the shape tree.

    For example:

    ```ruby
    class NG; end

    HUGE_NUMBER.times do
      NG.new.instance_variable_set(:"@unique_ivar_#{_1}", 1)
    end
    ```

    We consider objects to be "too complex" when the object's class has more
    than SHAPE_MAX_VARIATIONS (currently 8) leaf nodes in the shape tree and
    the object introduces a new variation (a new leaf node) associated with
    that class.

    For example, new variations on instances of the following class would be
    considered "too complex" because those instances create more than 8
    leaves in the shape tree:

    ```ruby
    class Foo; end
    9.times { Foo.new.instance_variable_set(":@uniq_#{_1}", 1) }
    ```

    However, the following class is *not* too complex because it only has
    one leaf in the shape tree:

    ```ruby
    class Foo
      def initialize
        @a = @b = @c = @d = @e = @f = @g = @h = @i = nil
      end
    end
    9.times { Foo.new }
    ``

    This case is rare, so we don't expect this change to impact performance
    of most applications, but it needs to be handled.

    Co-Authored-By: Aaron Patterson <tenderlove@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6931

commit a3d552aedd190b0f21a4f6479f0ef1d2ce90189b
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2022-12-09 06:48:48 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2022-12-16 03:06:04 +0900

    Add variation_count on classes

    Count how many "variations" each class creates. A "variation" is a a
    unique ordering of instance variables on a particular class. This can
    also be thought of as a branch in the shape tree.

    For example, the following Foo class will have 2 variations:

    ```ruby
    class Foo ; end

    Foo.new.instance_variable_set(:@a, 1) # case 1: creates one variation
    Foo.new.instance_variable_set(:@b, 1) # case 2: creates another variation

    foo = Foo.new
    foo.instance_variable_set(:@a, 1) # does not create a new variation
    foo.instance_variable_set(:@b, 1) # does not create a new variation (a continuation of the variation in case 1)
    ```

    We will use this number to limit the amount of shapes that a class can
    create and fallback to using a hash iv lookup.

    Co-Authored-By: Aaron Patterson <tenderlove@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6931

commit f50aa19da63067c4b0de5964b6632df20202e71c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-16 02:00:30 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-16 02:00:30 +0900

    Revert "Fix Object Movement allocation in GC"

    This reverts commit 9c54466e299aa91af225bc2d92a3d7755730948f.

    We're seeing crashes in Shopify CI after this commit.

commit 9c54466e299aa91af225bc2d92a3d7755730948f
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2022-12-14 00:11:57 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-15 23:04:30 +0900

    Fix Object Movement allocation in GC

    When moving Objects between size pools we have to assign a new shape.

    This happened during updating references - we tried to create a new shape
    tree that mirrored the existing tree, but based on the root shape of the
    new size pool.

    This causes allocations to happen if the new tree doesn't already exist,
    potentially triggering a GC, during GC.

    This commit changes object movement to look for a pre-existing new tree
    during object movement, and if that tree does not exist, we don't move
    the object to the new pool.

    This allows us to remove the shape allocation from update references.

    Co-Authored-By: Peter Zhu <peter@peterzhu.ca>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6926

commit 723cca6d82ecaeb41d7922571a88f15439048098
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-15 22:20:17 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-15 22:20:17 +0900

    Update bundled gems list at e3ed6c07832edf2a95bae3bdd908cc [ci skip]

commit e3ed6c07832edf2a95bae3bdd908cc3f5b65eebe
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2022-12-15 22:18:52 +0900
  Commit:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  CommitDate: 2022-12-15 22:18:52 +0900

    Update bundled_gems

commit 49b0f3b024855efad66a386595eabd103058826d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-15 18:00:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-15 19:06:40 +0900

    Merge RubyGems/Bundler master

      Pick from https://github.com/rubygems/rubygems/commit/084f7d1f21f6fc3e2bb685b7bda3653fb2891c6e

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6936

commit 2581de112c1957dc4b5852e54337551dc8972c99
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2022-12-15 15:12:33 +0900
  Commit:     Shugo Maeda <shugo.maeda@gmail.com>
  CommitDate: 2022-12-15 18:56:24 +0900

    Disallow mixed usage of ... and */**

    [Feature #19134]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6934

commit 613fca01486e47dee9364a2fd86b5f5e77fe23c8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-07 22:14:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-15 11:00:42 +0900

    [Bug #19189] Fallback to the default "pkg-config"

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6927

commit d20bd06a97555a4493458d866590107da6cb21f4
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2022-12-15 07:37:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-15 07:37:01 +0900

    Remove `require 'io/wait'` where it's no longer necessary. (#6932)

    * Remove `require 'io/wait'` as it's part of core now.

    * Update ruby specs using version gates.

    * Add note about why it's conditional.

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 55f56eb66e9045943c4b61876b67bcd971666788
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2022-12-15 07:13:23 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-15 07:13:28 +0900

    [ruby/net-http] [DOC] New doc for responses classes
    (https://github.com/ruby/net-http/pull/91)

    https://github.com/ruby/net-http/commit/d394404402

commit d2b87456f0e0046630dea9dd7fae4ec6324e9e92
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2022-12-15 06:34:07 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-15 06:34:12 +0900

    [ruby/net-http] [DOC] Correct formatting in header.rb
    (https://github.com/ruby/net-http/pull/90)

    https://github.com/ruby/net-http/commit/d9d829ca53

commit 693c01d50917071433ff1bc7c4d8ce626a12c48e
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-15 05:12:44 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2022-12-15 06:17:46 +0900

    YJIT: Remove duplicate call to jit_prepare_routine_call()

    It's idempotent.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6930

commit 7a63114f8eaba7a1fe8a56a2e665703d9f9cfa8a
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-15 00:57:44 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-15 03:21:46 +0900

    Remove dead code in get_next_shape_internal

    If the rb_id_table_lookup fails, then res is not updated so it cannot be
    any value other than null.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6928

commit 71dd8b3caa6462e5c3dfd7059314459b51ebebc0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-15 00:27:47 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-15 00:27:47 +0900

    socket.rb - simplify check for the method

commit 9eb19a02aea2f867972d2c28cab25e5df162091f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2022-12-15 00:14:00 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2022-12-15 00:14:00 +0900

    Add more comments why CRuby uses __pioinfo

commit 1df6d0e57828de9606613db940e32aa5b15eff18
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2022-12-14 23:19:56 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2022-12-14 23:53:41 +0900

    objspace_dump.c: don't dump class of T_IMEMO

    They don't actually have a class.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6925

commit cca54c8b1b71072bb07850c9d3f20b261d3b312c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-14 03:34:06 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-14 22:56:19 +0900

    [ci skip] Add entry to NEWS.md about VWA

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6919

commit 3e5f8b2af305daee719dedf0162be1652e336447
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2022-12-14 22:54:59 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 22:55:06 +0900

    [ruby/net-http] [DOC] Enhanced RDoc for Net::HTTP
    (https://github.com/ruby/net-http/pull/89)

    https://github.com/ruby/net-http/commit/86b84eb307

commit 3e104b4419caecb9cd328f36169d993fe86d983c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-12 13:33:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 19:11:07 +0900

    [rubygems/rubygems] Clean up Indexer build files in tests

    https://github.com/rubygems/rubygems/commit/5479d99a1d

commit 45e84d177952c2597b5ef32f02e68dc29109e7bd
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 17:49:28 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 17:49:28 +0900

    Update default gems list at 1a8d460534c7423091b790530bb3ea [ci skip]

commit 1a8d460534c7423091b790530bb3ead4840820c4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 17:47:44 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 17:48:38 +0900

    [ruby/securerandom] Bump version to 0.2.2

    https://github.com/ruby/securerandom/commit/9e16b597f5

commit 31bc403e88fe2dbe9e9b8699afb429ab1a97ca59
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 17:43:10 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 17:43:10 +0900

    Update default gems list at 95d7b5e2e933cf74cc29782ce33b65 [ci skip]

commit 95d7b5e2e933cf74cc29782ce33b6503e874890d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 16:36:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-14 17:42:15 +0900

    [ruby/resolv-replace] Bump version to 0.1.1

    https://github.com/ruby/resolv-replace/commit/187e91d149

commit bec7deba306572a130e971b53a82270a7b1255c6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 16:44:47 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:56:09 +0900

    [ruby/date] Fixed wrong minimum version of Ruby

      Fixed https://github.com/ruby/date/issues/83

    https://github.com/ruby/date/commit/9731a3e732

commit f60c080849b000e2a37b23f410da21ce91c8ecab
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 16:54:33 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:54:33 +0900

    Update default gems list at 15f5842a5fe57fdc9af28494609cbd [ci skip]

commit 15f5842a5fe57fdc9af28494609cbd2c9901d40f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 16:51:37 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:53:51 +0900

    [ruby/English] Bump version to 0.7.2

    https://github.com/ruby/English/commit/736f819b3b

commit d652474a66289163841d138a08f8a8c6b18d4b9a
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 16:39:20 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:39:20 +0900

    Update default gems list at 0b67e435ed07a2febf7c7bd4911257 [ci skip]

commit 0b67e435ed07a2febf7c7bd4911257a8f4836779
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 16:38:17 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:38:37 +0900

    [ruby/abbrev] Bump version to 0.1.1

    https://github.com/ruby/abbrev/commit/8c3debac5a

commit 82b61f53be68f06ac68fc932af624250c0228098
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 16:08:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:08:24 +0900

    Update default gems list at c6f41a3255e55d6a30bc8ef557bfba [ci skip]

commit c6f41a3255e55d6a30bc8ef557bfba1c87a7a868
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 15:14:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-14 16:07:44 +0900

    [ruby/time] Bump version to 0.2.1

    https://github.com/ruby/time/commit/4cebf6de3c

commit c96ffd36e2f31acd0c4f8b8373b6be903878c946
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 16:01:55 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:01:55 +0900

    Update default gems list at 989d993f5b03fbbf712554abe7f93b [ci skip]

commit 989d993f5b03fbbf712554abe7f93bbeaad6298c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 15:59:59 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 16:01:19 +0900

    [ruby/reline] Bump version to 0.3.2

    https://github.com/ruby/reline/commit/3fbb7ec2ae

commit 20c34f10d799c6b10a657a266db3aa6c51c850d3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 15:44:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-14 15:46:19 +0900

    Use versioning sort for released version detection

commit 307d2e0e91632a61cc492653a47027fbce7332d4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-14 15:40:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-14 15:40:13 +0900

    Skip yet another flaky Ractor test

commit 65dfe2eea80bef95c1bebc990780314f8118ec0d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-14 15:25:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-14 15:26:24 +0900

    Suppress the output of `if [ 'xyes' = xyes ];` code

    itself

commit 00acc9b05762df8bb86fbb7499b38f00ad331829
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 15:18:45 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 15:18:45 +0900

    Update default gems list at 9e4d7e99ce5686760ef2eab0d8b4f9 [ci skip]

commit 9e4d7e99ce5686760ef2eab0d8b4f933c1c665dc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 15:17:51 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 15:18:10 +0900

    [ruby/syslog] Bump version to 0.1.1

    https://github.com/ruby/syslog/commit/a92b55b638

commit c4009a2e836f4d16800edb37750bb5b2041963a6
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 15:17:14 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 15:17:14 +0900

    Update default gems list at e2f4b8bf77ac29b2b94fc01d6d2d63 [ci skip]

commit e2f4b8bf77ac29b2b94fc01d6d2d6365d5ff4345
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 15:16:10 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 15:16:29 +0900

    [ruby/weakref] Bump version to 0.1.2

    https://github.com/ruby/weakref/commit/5b5f79d8a6

commit abf9a321823184f73a5aaf3c8e25291e75f94a84
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-14 15:06:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-14 15:07:42 +0900

    Match ABI versions precisely

    "3.2.0+33" starts with "3.2.0+3", but it doesn't mean that they are the
    same ABI version.

commit 2d5b723b2f69dda8c7cf0de69c25e16a1818b88c
  Author:     Jimmy Miller <jimmy.miller@shopify.com>
  AuthorDate: 2022-12-14 14:59:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-14 14:59:21 +0900

    Fix build when enable_shared is on (#6924)

    Before this change, if enable_shared was true, the directory would have a suffix of -static and be deleted on each make install. This would cause a second make install to fail.

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit a7cf39bba859f5b31ec2e5c7e9c2993d31c6e154
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 14:54:44 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 14:54:44 +0900

    Update default gems list at 87d32376d96d2c73083ac149df788e [ci skip]

commit 87d32376d96d2c73083ac149df788edc16543c05
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 14:53:44 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 14:54:06 +0900

    [ruby/readline-ext] Bump version to 0.1.5

    https://github.com/ruby/readline-ext/commit/7af996f24b

commit a3b2719a09af01789cb5eba79a243fdfea71c1ab
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 14:49:54 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 14:49:54 +0900

    Update default gems list at 0c27c1b3fca72e638a9d91705234e7 [ci skip]

commit 0c27c1b3fca72e638a9d91705234e7c4b2e236d4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 14:37:25 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 14:49:14 +0900

    [ruby/open3] Bump version to 0.1.2

    https://github.com/ruby/open3/commit/38904e204d

commit 6b41a2f9e76f51904a50a500cc5775d21f870a4a
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 14:36:41 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 14:36:41 +0900

    Update default gems list at 067747bb9a959808c47b32393170ca [ci skip]

commit 067747bb9a959808c47b32393170ca09e0214df4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 14:33:21 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 14:35:48 +0900

    [ruby/tempfile] Bump version to 0.1.3

    https://github.com/ruby/tempfile/commit/99dc1f7058

commit 03927b565b9b6c8578c6a1c6f8e17e72ef82a05e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-14 12:57:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-14 12:57:30 +0900

    Pin syntax_suggest-1.0.1 manually because it mixed dead_end tags

commit fbedadb61f49ba3aaf4f07939b4fc7d0b8f8ac03
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2022-12-14 12:57:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-14 12:57:14 +0900

    Add `Regexp.linear_time?` (#6901)

  Notes:
    Merged-By: makenowjust <make.just.on@gmail.com>

commit fe3cbc61c805a860da3d41253879708ec86b6aa2
  Author:     HASUMI Hitoshi <hasumikin@gmail.com>
  AuthorDate: 2022-12-14 09:00:27 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 09:00:39 +0900

    [ruby/reline] Fix a misparameter of RubyLex#set_input in
    termination_checker.rb
    (https://github.com/ruby/reline/pull/482)

    * Fix a misparameter of RubyLex#set_input in termination_checker.rb

    The keyword parameter `:context` of RubyLex#set_input became mandatory due to this commit:
    https://github.com/ruby/irb/pull/427/files#diff-612b926e42ed78aed1a889ac1944f7d22229b3a489cc08f837a7f75eca3d3399R51

    Without my patch, tests that specify "--auto-indent" option in test_yamatanooroti fall into an infinite loop.

    This would need more explanation:
    - The infinite loop happens in Yamatanooroti::VTermTestCaseModule#sync
      see: https://github.com/aycabta/yamatanooroti/blob/v0.0.9/lib/yamatanooroti/vterm.rb#L60-L63
    - `@pty_output.read_nonblock(1024)` actually returned an exception
    - However, this method doesn't anticipate such a situation
    - As a result, `startup_message` couldn't be resolved for good and the
      infinite loop happens
    - I think we would eventually have to fix yamatanooroti, though the
      inconsistency of the kwarg of "set_input" has to be fixed anyway

    The actual exception message that is raised but ignored silently in Yamatanooroti::VTermTestCaseModule#sync:

    ```
    /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/bundler/gems/irb-d30c0c994351/lib/irb/ruby-lex.rb:51:in `set_input': missing keyword: :context (ArgumentError)
            from /home/hasumi/work/ruby/reline/test/reline/yamatanooroti/termination_checker.rb:23:in `initialize'
            from /home/hasumi/work/ruby/reline/test/reline/yamatanooroti/multiline_repl:43:in `new'
            from /home/hasumi/work/ruby/reline/test/reline/yamatanooroti/multiline_repl:43:in `block in <main>'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/3.1.0/optparse.rb:1576:in `block in parse_in_order'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/3.1.0/optparse.rb:1559:in `catch'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/3.1.0/optparse.rb:1559:in `parse_in_order'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/3.1.0/optparse.rb:1553:in `order!'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/3.1.0/optparse.rb:1659:in `permute!'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/3.1.0/optparse.rb:1684:in `parse!'
            from /home/hasumi/work/ruby/reline/test/reline/yamatanooroti/multiline_repl:174:in `<main>'
    ```

    Backtrace of an inifinite loop:

    ```
    /home/hasumi/work/ruby/yamatanooroti/lib/yamatanooroti/vterm.rb:59:in `sleep': Interrupt
            from /home/hasumi/work/ruby/yamatanooroti/lib/yamatanooroti/vterm.rb:59:in `block in sync'
            from /home/hasumi/work/ruby/yamatanooroti/lib/yamatanooroti/vterm.rb:58:in `loop'
            from /home/hasumi/work/ruby/yamatanooroti/lib/yamatanooroti/vterm.rb:58:in `sync'
            from /home/hasumi/work/ruby/yamatanooroti/lib/yamatanooroti/vterm.rb:28:in `start_terminal'
            from /home/hasumi/work/ruby/reline/test/reline/yamatanooroti/test_rendering.rb:653:in `test_suppress_auto_indent_just_after_pasted'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testcase.rb:871:in `run_test'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testcase.rb:566:in `block (2 levels) in run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/fixture.rb:276:in `block in create_fixtures_runner'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/fixture.rb:276:in `block in create_fixtures_runner'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/fixture.rb:257:in `run_fixture'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/fixture.rb:292:in `run_setup'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testcase.rb:564:in `block in run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testcase.rb:563:in `catch'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testcase.rb:563:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:124:in `run_test'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:53:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:124:in `run_test'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:53:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:124:in `run_test'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:53:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:124:in `run_test'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/testsuite.rb:53:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunnermediator.rb:67:in `run_suite'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunnermediator.rb:45:in `block (2 levels) in run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunnermediator.rb:102:in `with_listener'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunnermediator.rb:41:in `block in run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunnermediator.rb:39:in `catch'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunnermediator.rb:39:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunner.rb:40:in `start_mediator'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunner.rb:25:in `start'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/ui/testrunnerutilities.rb:24:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/autorunner.rb:458:in `block in run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/autorunner.rb:514:in `change_work_directory'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/autorunner.rb:457:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit/autorunner.rb:66:in `run'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/gems/test-unit-3.5.5/lib/test/unit.rb:518:in `block (2 levels) in <top (required)>'
    ```

    * Fix mock object of Context

    The previous commit solved one problem, but it found the next problem.

    Following error message got from the command `RELINE_STDERR_TTY=error.log rake test_yamatanooroti`:

    ```
    Reline is used by 24373
    /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/bundler/gems/irb-d30c0c994351/lib/irb/ruby-lex.rb:151:in `ripper_lex_without_warning': private method `local_variables' called for #<struct auto_indent_mode=true, workspace=nil> (NoMethodError)

        lvars_code = generate_local_variables_assign_code(context&.local_variables || [])
                                                                 ^^^^^^^^^^^^^^^^^
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/gems/3.1.0/bundler/gems/irb-d30c0c994351/lib/irb/ruby-lex.rb:213:in `block in set_auto_indent'
            from /home/hasumi/work/ruby/reline/lib/reline/line_editor.rb:1721:in `process_auto_indent'
            from /home/hasumi/work/ruby/reline/lib/reline/line_editor.rb:1663:in `input_key'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:346:in `block (3 levels) in inner_readline'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:345:in `each'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:345:in `block (2 levels) in inner_readline'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:420:in `block in read_io'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:390:in `loop'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:390:in `read_io'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:343:in `block in inner_readline'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:341:in `loop'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:341:in `inner_readline'
            from /home/hasumi/work/ruby/reline/lib/reline.rb:271:in `readmultiline'
            from /home/hasumi/.rbenv/versions/3.1.2/lib/ruby/3.1.0/forwardable.rb:238:in `readmultiline'
            from /home/hasumi/work/ruby/reline/test/reline/yamatanooroti/multiline_repl:185:in `<main>'
    ```

    In irb/ruby-lex.rb, `context` is originally supposed to be an instance of IRB::Context with a public method `#local_variables`.
    However, the `context` in reline/test/reline/yamatanooroti/termination_checker.rb is a Struct that is a mock object with no `#local_variables` method.

    Thus, `rake test_yamatanooroti` no longer causes an infinite loop and an unexpected error with these two commits (at least in WITH_VTERM environment)

    * Name the Struct "MockIRBContext" to specify what it is for

commit 83c12b5baaf59a48fccab56850278fd3578bc542
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2022-12-13 20:15:00 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-14 05:42:14 +0900

    [ci skip] Fix Doxygen for ROBJECT Macro

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6917

commit 74995162fc5d530e1a7a91b9f5c11a3b270f7f5f
  Author:     MSP-Greg <MSP-Greg@users.noreply.github.com>
  AuthorDate: 2022-12-14 04:57:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-14 04:57:38 +0900

    socket.rb - don't load io/wait (#6922)

    See d2166c09b08fc1 and #6036 for more context.

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 1859784422ca7f19710bbfb1b12b46fdd8ecf3cb
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-12-07 02:57:51 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 04:52:06 +0900

    [ruby/date] Implement Date#deconstruct_keys and DateTime#deconstruct_keys

    https://github.com/ruby/date/commit/6bb6d3a810

commit 25f727d4caf72056b5c88ac2ea292093a9a06099
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-14 03:37:48 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 03:37:48 +0900

    Update default gems list at a1dba60b5bec6b25e8262640228e19 [ci skip]

commit a1dba60b5bec6b25e8262640228e19329d0dfec2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-14 03:36:34 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-14 03:36:45 +0900

    [ruby/irb] Version 1.6.1

    https://github.com/ruby/irb/commit/229476ba76

commit 856e0279ec990ef3b41285077429da47200d5a73
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2022-12-13 23:56:55 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-14 03:31:10 +0900

    fix indentation: gc_compact_destination_pool

    [ci skip]

    Co-Authored-By: Peter Zhu <peter@peterzhu.ca>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6918

commit a66a69865d444509710253d3210a1e72bcd040f9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-14 01:00:22 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-14 01:00:22 +0900

    YJIT: Change the default mem size to 64MiB (#6912)

    * YJIT: Change the default mem size to 64MiB

    * Also update ruby --help

    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 99d0a257af54aa819c6ced5f1ff8ff37e3d5342b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-13 19:47:26 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-13 19:55:18 +0900

    [ruby/openssl] [DOC] Remove duplicate doc

    RDoc does not consider preprocessor conditionals, but equally uses
    both documents of `#if` and `#else` sides.

    https://github.com/ruby/openssl/commit/ea0a112a0c

commit 3de7ff8eb9eb74e0dbd48902d1535d3c9fe14005
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-13 17:47:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 18:07:41 +0900

    We should apply https://github.com/ruby/openssl/pull/576 instead of them:

      https://github.com/ruby/ruby/commit/6d8f396f37350b7aa9c85a097929f54a0939448b
      https://github.com/ruby/ruby/commit/c8b3bd45cc3cae93ae701333202416838ee6a00c

commit 2be03fb5b0fc6ba18cf9842f410f3853e0369600
  Author:     Henrique Bontempo <henrique.s.bontempo@gmail.com>
  AuthorDate: 2022-11-24 02:04:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 18:07:41 +0900

    [ruby/openssl] Fixes OPENSSL_LIBRARY_VERSION description on
    documentation
    (https://github.com/ruby/openssl/pull/559)

    Adds back missing constant description on the documentation.

commit 8ab8c2d601db398c2d0e17db2105acb561ef0e04
  Author:     Theo Buehler <tb@openbsd.org>
  AuthorDate: 2022-11-24 01:09:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 18:07:41 +0900

    [ruby/openssl] Enable HKDF support for LibreSSL 3.6 and later

    LibreSSL 3.6 added support for HKDF in EVP. Enable this in ossl_kdf.c.

    https://github.com/ruby/openssl/commit/9bdd39a7e2

commit d4dce27d894f4889f29d779c94ba2d30c231f9f8
  Author:     Yusuke Nakamura <yusuke1994525@gmail.com>
  AuthorDate: 2022-11-23 21:05:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 18:07:41 +0900

    [ruby/openssl] Allow empty string to OpenSSL::Cipher#update

    For some reasons, plaintext may be empty string.

    ref https://www.rfc-editor.org/rfc/rfc9001.html#section-5.8

    https://github.com/ruby/openssl/commit/953592a29e

commit d92f4fe4d74d929cec9ca36ec3dbec070b314902
  Author:     Theo Buehler <tb@openbsd.org>
  AuthorDate: 2022-11-10 22:50:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 18:07:41 +0900

    [ruby/openssl] Use EVP_Digest{Sign,Verify} when available

    LibreSSL 3.4 added EVP_DigestSign() and EVP_DigestVerify(). Use them
    when available to prepare for the addition of Ed25519 support in
    LibreSSL 3.7.

    https://github.com/ruby/openssl/commit/475b2bf766

commit ce025a5cb4a7aea62629fcf8685e931671a0672d
  Author:     Jarek Prokop <jprokop@redhat.com>
  AuthorDate: 2022-10-18 16:52:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 18:07:41 +0900

    [ruby/openssl] Use SHA256 instead of SHA1 where needed in tests.

    Systems such as RHEL 9 are moving away from SHA1
    disabling it completely in default configuration.

    https://github.com/ruby/openssl/commit/32648da2f6

commit 764da87ab02d30c578138bdb0f37e7c18f2d4371
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-13 15:18:42 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-13 18:06:11 +0900

    [Bug #19195] Allow optional newlines before closing parenthesis

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6916

commit 3262842e0adaed63935923bdc14884ac19d7549c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-13 17:22:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-13 17:25:02 +0900

    Skip calling f.read for `overwrite: true`-only cases

    We only need to set outpath for that case.

commit 5ba9dcff16226bbe0f24b234e62e2ed67a17ac53
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-13 17:15:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-13 17:17:47 +0900

    Make sure f.read is not called twice

    --revision.h and --if-change are not used simultaneously, but they might
    be in the future.

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit 7edcdc380f3bb6f5a81bfb5798c339acd844a0d3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-13 16:34:30 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-13 16:34:30 +0900

    Avoid overwriting revision.h when .git doesn't exist (#6915)

    * Avoid overwriting revision.h when .git doesn't exist

    * Overwrite revision.h if it's blank

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 3e00cb8256cfe0640cb1d744d07d496128edb7e9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-13 11:24:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 12:41:08 +0900

    Merge RubyGems/Bundler master

      from https://github.com/rubygems/rubygems/commit/1fdbeeabedd3cc4fffb0bb527b7c789afa44fb51

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6914

commit 6d00053c741cc7a369a1967e0631e32ddf3d1f82
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-12 04:17:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 12:41:08 +0900

    [rubygems/rubygems] Use better matcher

    Hopefully it gives a better error.

    https://github.com/rubygems/rubygems/commit/5bc9ff64b6

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6914

commit 91050d3443956a2841aa91defee0d178a18fc347
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-13 05:07:54 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-13 07:29:39 +0900

    [rubygems/rubygems] Bump rb-sys in /test/rubygems/test_gem_ext_cargo_builder/custom_name

    Bumps [rb-sys](https://github.com/oxidize-rb/rb-sys) from 0.9.46 to 0.9.48.
    - [Release notes](https://github.com/oxidize-rb/rb-sys/releases)
    - [Commits](https://github.com/oxidize-rb/rb-sys/compare/v0.9.46...v0.9.48)

    ---
    updated-dependencies:
    - dependency-name: rb-sys
      dependency-type: direct:production
      update-type: version-update:semver-patch
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

commit 43f9351177c14c554d88630b3db771b2faf11dd0
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2022-12-13 04:09:10 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2022-12-13 07:05:43 +0900

    Fix parens on LIKELY in basic operators

    We want to hint to the compiler that it's likely that the BOP is
    unredefined (the bit is 0). Previously we were accidentally hinting to
    the compiler that it was non-zero due to a misplaced parenthesis.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6911

commit 17559f0420fd925147156e7434916b58c830f44c
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-12 20:19:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-13 07:01:52 +0900

    Don't leave backup file around

    I suspect this was for debugging? If not, these days we have source
    control tools, so this wouldn't seem necessary?

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6907

commit f88f2bd92f4a1760c0f323614c45369d6a281317
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2022-12-13 06:04:58 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-13 06:05:03 +0900

    [ruby/irb] Group show_doc tests and update the expectation
    (https://github.com/ruby/irb/pull/479)

    https://github.com/ruby/irb/commit/bede04c14a

commit 258ac07907b2e3561db48d53ed0a50c8dd05f102
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-13 05:59:29 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-13 05:59:29 +0900

    YJIT: Generate debug info in release builds (#6910)

    * YJIT: Generate debug info in release builds

    They are helpful in case we need to do core dump debugging.

    * Remove Cirrus DOC skip rule

    The syntax for this is weird, and escaping [ and ] cause parse failures.
    Cirrus' docs said to surround with .*, but then that seems to skip
    everything. Revert e0a4205eb785f266fdf08f409c2f112f5dfcb229 for now.

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 1004d693b7a3db5db98be59a3d3d468d2ee21ca5
  Author:     Maxime Chevalier-Boisvert <maxime.chevalierboisvert@shopify.com>
  AuthorDate: 2022-12-13 05:13:46 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-13 05:13:46 +0900

    Make it so YJIT is no longer marked as experimental (#6909)

    Tested on production workloads at Shopify for > 1 year and proven
    to be quite stable. Enabling YJIT at run-time is still guarded
    behind the --yjit command-line option for now.

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 8e619b8e0ebbfd2e6ceb9fa69d67846796eb716e
  Author:     dependabot[bot] <49699333+dependabot[bot]@users.noreply.github.com>
  AuthorDate: 2022-12-13 00:07:38 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-13 05:04:00 +0900

    [rubygems/rubygems] Bump rb-sys

    Bumps [rb-sys](https://github.com/oxidize-rb/rb-sys) from 0.9.46 to 0.9.48.
    - [Release notes](https://github.com/oxidize-rb/rb-sys/releases)
    - [Commits](https://github.com/oxidize-rb/rb-sys/compare/v0.9.46...v0.9.48)

    ---
    updated-dependencies:
    - dependency-name: rb-sys
      dependency-type: direct:production
      update-type: version-update:semver-patch
    ...

    Signed-off-by: dependabot[bot] <support@github.com>

commit 63f682ba11d92f5f9c1254c491d5881b1614731a
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2022-12-13 04:34:15 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-13 04:34:21 +0900

    [ruby/net-http] [DOC] Enhanced RDoc for HTTPHeader
    (https://github.com/ruby/net-http/pull/88)

    https://github.com/ruby/net-http/commit/46e966be10

commit 223d4448c827b9daeb6a61312777e67405e66379
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2022-12-13 02:35:43 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-13 02:35:48 +0900

    [ruby/irb] `show_doc` command should take non-string argument too
    (https://github.com/ruby/irb/pull/478)

    Given that `show_doc` already supports syntax like `String#gsub`, it
    should be able to take it in non-string form too, like `edit` and
    `show_source` do. This ensures users can have a consistent syntax on
    argument between different commands.

commit ece624605785f6640118a0cfd97618e71abfbee8
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-13 00:19:24 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-13 00:19:24 +0900

    YJIT: Implement opt_newarray_max instruction (#6893)

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 5302d04e5a7fe226a4e9f6aba8b681e0d5088b27
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-13 00:16:38 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-13 00:16:38 +0900

    [DOC] Fix format in ObjectSpace.dump_all

commit be710c1bf797f539707e00a1ec6bf86e6009add0
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-13 00:15:24 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-13 00:15:24 +0900

    [DOC] Fix format for ObjectSpace.dump_shapes

commit a9c3dc8d2ea4f2461862a999ce40cf944af97190
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-12 23:58:39 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-12 23:58:39 +0900

    [DOC] Fix call-seq for ObjectSpace methods

commit 58e3ce5de6e54e4ede6ab6c5df2426ddb92b5a17
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-12 23:56:44 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-12 23:56:44 +0900

    [DOC] Fix typo in docs for ObjectSpace.dump_all

commit 87d54708735a77c867638e3157695d75cab279b3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-12 23:51:12 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-12 23:51:12 +0900

    [DOC] Fix indentation for ObjectSpace.dump_all

commit 0b4fda11ec918e8f40059cfd1d2f417bf780d60d
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2022-12-12 23:37:31 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-12 23:48:06 +0900

    [DOC] Don't document private methods in objspace

commit 6d6b1e599034717c8c8df67ece0d4abb4e12d4cb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-12 13:38:12 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-12 23:32:37 +0900

    Display error messages outside the groups so can be found quickly

commit e809bd31fd7877ea4e302c18cbd42f1b2d685728
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-12 13:17:56 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-12 23:32:37 +0900

    Fix positional argument color [ci skip]

commit 0ba65c689e27b0b6229fbb40fc6794d0c853a33f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-12 17:05:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-12 17:05:37 +0900

    outdate-bundled-gems.rb: check for gemspec files for extensions

    https://github.com/ruby/setup-ruby/issues/415#issuecomment-1345662263

commit ff6831c3343a3d30fdccb0932b8ae0834ee85709
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-12 17:05:03 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-12 17:05:03 +0900

    outdate-bundled-gems.rb: remove unused option

commit be18b60c335ea0d557717470826a489939316192
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-09 14:19:31 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-12 16:21:31 +0900

    Prevent potential buffer overflow on enclen

    Follow up of 1d2d25dcadda0764f303183ac091d0c87b432566

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6903

commit e1f42844a0b2a4dcf4c7338c41ef92f1b45393d8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-07-27 09:59:11 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-12 15:00:41 +0900

    [rubygems/rubygems] Prefer RbConfig::CONFIG['EXEEXT'] over hardcorded '.exe'

    https://github.com/rubygems/rubygems/commit/bc84b2d262

commit b8e542b46350cc1e7975bb711082e4cc6fcb7c82
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2022-12-09 14:17:35 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2022-12-12 14:26:38 +0900

    Make absent operator work at the end of the input string

    https://bugs.ruby-lang.org/issues/19104#change-100542

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6902

commit f093b619a4863be96e6ebfa2fd58c77f4a360eae
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-12 13:56:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-12 13:56:06 +0900

    [DOC] NEWS about [Feature #19104]

commit bbe56a643734025aef6a3cbeb07c5306505040f6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-12 09:09:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-12 10:49:43 +0900

    Merge RubyGems/Bundler master

      from https://github.com/rubygems/rubygems/commit/bfb0ae69776069155d2092702bfbb5a12617d85a

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6906

commit f1cdc129d4d6440168b840fa852fa6c3e28d46a9
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2022-12-12 07:26:06 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-12 07:26:18 +0900

    [ruby/net-http] [DOC] Enhanced RDoc for Net::HTTP
    (https://github.com/ruby/net-http/pull/85)

    https://github.com/ruby/net-http/commit/9d9040fb79

commit e1ca089b5dddd30c4ac8de9c7ec9e52948768117
  Author:     Jonathan Lim <snowblink@gmail.com>
  AuthorDate: 2022-12-12 02:24:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-12 02:24:01 +0900

    [DOC] Correct Array#compact! description

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6904

    Merged-By: XrXr

commit e0a4205eb785f266fdf08f409c2f112f5dfcb229
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-12 02:02:05 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2022-12-12 02:14:04 +0900

    Skip Cirrus checks for [DOC] commits

    Since we also skip them on GitHub Actions.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6905

commit 381a373ab92e2a5869e75f43815993cef39d32cf
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-01-13 05:05:30 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-12 01:49:56 +0900

    [DOC] Improve Random::Formatter docs

    * Make its usage more obvious (by providing more detailed
      examples);
    * Include mention of it into Random itself;
    * Small cleanups of docs.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5434

commit f07897fd7bb53a40a8fad5ee2be74e02b53e8614
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2022-01-25 07:31:12 +0900
  Commit:     Victor Shepelev <zverok.offline@gmail.com>
  CommitDate: 2022-12-12 01:43:44 +0900

    [DOC] Clarify Class#subclases behavior quirks

    As per discussion in [Feature #18273], explain the
    non-deterministic nature of the method.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/5480

commit 73eddee76efdc4ed255fd13533b4a0a329cf3b1a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-11 06:10:43 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-11 22:35:01 +0900

    [rubygems/rubygems] Bump optparse to 0.3.0

    And remove a patch no longer needed since we dropped Ruby 2.4 support.

    https://github.com/rubygems/rubygems/commit/8939337072

commit d82328ffc8b70564cb84ee8ec8c3d90884234eb7
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-12-11 06:05:03 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-11 22:35:00 +0900

    [rubygems/rubygems] Bump Molinillo and tsort

    And configure tsort to be vendored as a dependency of Molinillo.

    https://github.com/rubygems/rubygems/commit/8ec749f891

commit 9477ec732b680df1ffa1d17b86ba641c83dc4b74
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-12-11 20:23:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-12-11 20:23:36 +0900

    NEWS.md: fix ticket ref position.

commit d245c2ec481b133eb3334f7e18be22c14610994b
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2022-12-11 19:27:21 +0900
  Commit:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  CommitDate: 2022-12-11 19:27:21 +0900

    Fix typos [ci skip]

commit 9d59d093bd99ca7f4266dec1e9b4cd8b5efbd2d4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-11 15:21:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-11 15:21:06 +0900

    MJIT: Compile methods in batches (#6900)

    * MJIT: Compile methods in batches

    * MJIT: make mjit-bindgen

    * MJIT: Fix RubyVM::MJIT tests

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 7055574cf9dbcabd9d440c364f3e7b7812527bde
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-06 22:16:29 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-11 11:55:28 +0900

    [Bug #19182] Unicode updating targets do not need to run for each files

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6899

commit ea613c63608232bf33fd454fc6cd1ce20d63d82e
  Author:     Mirek Klimos <myreggg@gmail.com>
  AuthorDate: 2022-12-11 03:35:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-11 03:35:31 +0900

    Expose need_major_gc via GC.latest_gc_info (#6791)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 12003acbb9c2c2624be8c41c22c15e6d1fa3a42e
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2022-12-10 03:33:48 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2022-12-11 00:10:21 +0900

    Update shape capacity when removing ivar and rewriting shape transitions

    Since edc7af48acd12666a2945f30901d16b62a39f474, we now no longer have
    undef ivar transitions. Instead, we rebuild the shapes table. When we do
    this, we need to ensure that we retain our capacities on shapes.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6894

commit 0645c8b3c1f7448d88c6fe6a4ebbd7b3a091c042
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-10 19:01:29 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-10 19:01:29 +0900

    [DOC] Fix update-NEWS-refs.rb

    * Issue numbers are path components but not fragments
    * Align justification width to Feature lines

commit fd440b09fc64b1d2275942c7f6d1e1f4069e85ae
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-10 18:57:20 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-10 18:57:20 +0900

    A negative denominator case in the Rational string parsing test

commit c33615b6543b46227e7f51c17c2d725cf5bfa2ef
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-12-10 16:10:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-12-10 16:10:39 +0900

    NEWS.md: Added compatibility issue of String#to_c. [ruby-core:110523] [Bug #19087]

commit fc8d22f89124d2b7f1df5de87274e86ccefadbd2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-10 04:24:01 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-10 13:58:20 +0900

    Win32: Move fallback BASERUBY definition

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6898

commit 7a976c106030f37d6ab72b1abaef10e575bb8809
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-06 16:47:42 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-10 13:58:20 +0900

    [Bug #19181] Separate the rule for unicode_normalize/tables.rb timestamp

    It should depends on only existing data files (except for the tools),
    unless `ALWAYS_UPDATE_UNICODE=yes`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6898

commit 5404e2fd31736af3a7477f3ec67d3f07276485d6
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2022-12-10 11:56:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-10 11:56:02 +0900

    [DOC] Fix false link to ::Data

commit 22d391dc637dd756fdcdfc0ece4a71753b5b2ddb
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2022-12-10 09:54:53 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-10 09:54:53 +0900

    Add spec for fiber storage. (#6896)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 24043031be75cb5119cc4a6c1ffb2c867b567633
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-10 09:45:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-10 09:45:38 +0900

    YJIT: Split send_iseq_complex_callee exit reasons (#6895)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 381e128c135e491689714cb69353d11e782f5994
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2022-12-10 08:39:12 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-10 08:39:17 +0900

    [ruby/irb] Fix step command (https://github.com/ruby/irb/pull/477)

    The current `next` pre-command workaround on IRB source stepping
    moves the location by 1 extra line. A better way is to make `debug`
    skip IRB frames completely, which is what this commit does.

    It also fixes the step command's test. The `|` in regexp was not escaped
    so it was always incorrectly matched.

commit daa893db412c6ae814d0291b4ac6fc62a466d394
  Author:     Maxime Chevalier-Boisvert <maxime.chevalierboisvert@shopify.com>
  AuthorDate: 2022-12-10 07:12:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-10 07:12:15 +0900

    YJIT: implement `getconstant` YARV instruction (#6884)

    * YJIT: implement getconstant YARV instruction

    * Constant id is not a pointer

    * Stack operands must be read after jit_prepare_routine_call

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 1c057cfc2fd84369a2ebff048c4a5fdf5fa08fff
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-10 06:14:19 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2022-12-10 06:14:19 +0900

    YJIT: Filter out 0-exit ops from Top-20 exit ops (#6892)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit d7812d1949b6315eff5088c6f74eaf9ef6b34119
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2022-12-09 23:22:10 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2022-12-10 01:06:21 +0900

    objspace_dump.c: dump the capacity field for INITIAL_CAPACITY shapes

    We forgot about that one, it's quite useful to see which capacity
    we started from.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6891

commit 12b52686790582e30d7d92f2070741d28be8c517
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2022-12-08 22:42:19 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2022-12-09 23:34:17 +0900

    Remove unused counter for heap_page->pinned_slots

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6881

commit fe67998816245fbab6a65095bde3d57f1277609c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-09 22:15:38 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-09 22:15:38 +0900

    Clean up a temporary file

commit 11acb7f7bcf6e80e03cf83bba863b9b3f980fdca
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-09 01:14:43 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-09 22:11:44 +0900

    [Bug #19167] Remove useless conversion of classes for special const

commit 181d4bee5e03a30596e78b2d7aa0396887a53881
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2022-12-08 01:01:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2022-12-09 22:11:00 +0900

    Use rb_inspect instead of +PRIsVALUE for Object.inspect

    In order to preserve the values when TrueClass, FalseClass or NilClass
    are stored in ivars

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6872

commit 7c438328d59e70fee82100caaa931ff163bd8daf
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-09 16:59:57 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-09 16:59:57 +0900

    Update default gems list at 01cf3ab3b8ee20ad6746373ae17a56 [ci skip]

commit 01cf3ab3b8ee20ad6746373ae17a5679cad47125
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-09 16:56:36 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-09 16:57:33 +0900

    [ruby/date] Bump version to 3.3.1

    https://github.com/ruby/date/commit/b7a8229041

commit e96b64f5e749425b63cc71f256da304fe3ee476b
  Author:     Charles Oliver Nutter <headius@headius.com>
  AuthorDate: 2022-12-09 13:43:46 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-09 16:55:07 +0900

    [ruby/date] No-op gem for JRuby for now

    Remove all shipped files and require path on JRuby until we can
    add JRuby's extension to the gem.

    Temporary workaround for #48

    https://github.com/ruby/date/commit/94c3becef2

commit f25e76fddd31ed51c17de2d5384e009c82d226f7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-09 16:48:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-09 16:48:30 +0900

    MJIT: Improve comments for JIT fields [ci skip]

commit 8893913ae6da33662201d0a0e6ba2d37f50630ca
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-12-09 16:41:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2022-12-09 16:43:09 +0900

    MJIT: Clarify jit_unit is only for MJIT

commit c668eaff1e5e775c9fa07c9cfa65aff0b3e11872
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-12-09 16:37:03 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-12-09 16:37:03 +0900

    Update default gems list at 93ac1503be10c43978fe7ee1fec95c [ci skip]

commit 93ac1503be10c43978fe7ee1fec95ca2098fbd26
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-09 15:13:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-09 16:36:22 +0900

    Added condition for ruby/ruby repository

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6890

commit 0677bbe3ff139a4f369c128bdab3526450c5ee6f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-09 15:12:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-09 16:36:22 +0900

    Merge syntax_suggest master

      Pick from https://github.com/ruby/syntax_suggest/commit/daee74dcb06296fa69fe8595fdff5d93d432b30d

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6890

commit 9557c8edf2dcf18fdece066c596a71696b2f2b30
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-09 15:00:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-09 16:36:22 +0900

    Merge net-protocol-0.2.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6890

commit 4cbd3e19447591f66c3ab08c322a32aa53eae74f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-09 14:54:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-09 16:36:22 +0900

    Merge RDoc-6.5.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6890

commit a4e14b9d9d58391fb7d7a10be8d883690860373b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-12-09 14:45:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2022-12-09 16:36:22 +0900

    Merge RubyGems/Bundler master

      Pick from https://github.com/rubygems/rubygems/commit/823c776d951f3c35094611473ec77f94e8bf6610

  Notes:
    Merged: https://github.com/ruby/ruby/pull/6890

